Package: BioImageDbs
Type: Package
Title: Bio- and biomedical imaging dataset for machine learning and
        deep learning (for ExperimentHub)
Version: 1.21.0
Encoding: UTF-8
Authors@R: c(
    person (given = "Satoshi", family = "Kume",
    role = c("aut", "cre"), 
    email = "satoshi.kume.1984@gmail.com",
    comment = c(ORCID = "0000-0001-7481-2843")),
    person(given = "Kozo", family = "Nishida",
    role = c("aut"),
    email = "kozo.nishida@gmail.com",
    comment = c(ORCID = "0000-0001-8501-7319"))
    )
Depends: R (>= 4.1.0)
Imports: ExperimentHub, AnnotationHub, markdown, rmarkdown, EBImage,
        magick, magrittr, filesstrings, animation, einsum
Suggests: knitr, BiocStyle, purrr
Description: The package provides a bioimage dataset for 
    the image analysis using machine learning and deep learning.
    The dataset includes microscopy imaging data with supervised labels.
    The data is provided as R list data that can be loaded to Keras/tensorflow 
    in R.
VignetteBuilder: knitr
License: Artistic-2.0
URL: https://kumes.github.io/BioImageDbs/
LazyLoad: yes
biocViews: ExperimentHub, ExperimentData, CellCulture, Tissue
RoxygenNote: 7.1.1
git_url: https://git.bioconductor.org/packages/BioImageDbs
git_branch: devel
git_last_commit: 5064eca
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.24
Date/Publication: 2026-04-30
NeedsCompilation: no
Packaged: 2026-04-30 15:29:44 UTC; biocbuild
Author: Satoshi Kume [aut, cre] (ORCID:
    <https://orcid.org/0000-0001-7481-2843>),
  Kozo Nishida [aut] (ORCID: <https://orcid.org/0000-0001-8501-7319>)
Maintainer: Satoshi Kume <satoshi.kume.1984@gmail.com>

# Default NAMESPACE created by R
# Remove the previous line if you edit this file

# Export all names
exportPattern("^[^.]")

# Import all packages listed as Imports or Depends
import(
  ExperimentHub,
  AnnotationHub,
  markdown,
  rmarkdown,
  EBImage,
  magick,
  magrittr,
  filesstrings,
  animation,
  einsum
)

# BioImageDbs

## Description

This package supplies ExperimentHub with 4D/5D arrays of microscopy-based imaging dataset 
including the original images and their supervised labels. 
This dataset is used for an evaluation of the bioimage analytical model using 
machine learning and deep learning. 
The dataset is provided as R list data of the multiple 4D/5D arrays that can be 
loaded to Keras/tensorflow in R. 

## Topics in this project
- R language usage / Bioconductor
- 2D/3D cellular images and their supervised labels for deep learning in R
- Sharing the bioimage dataset with 4D/5D array (tensor) structures via Bioconductor

  - Future plan
    - Sharing the trained deep learning models in R
    - Integrated usage with rMiW 

## Data source (GoogleDrive)

The original dataset is available in [Google Drive](https://drive.google.com/drive/folders/1pVCE1JukoY8U1VN4YZmVPFaGtPg80OY-?usp=sharing). 

## Vignettes

- [Providing Bioimage Dataset for ExperimentHub](https://kumes.github.io/BioImageDbs/vignettes/BioImageDbs.html)

- [The BioImageBbs Datasets](https://kumes.github.io/BioImageDbs/vignettes/BioImageBbs_Datasets.html)

- [make-data_for_v01](https://kumes.github.io/BioImageDbs/inst/scripts/v01/make-data_for_v01.html)

- [make-data_for_v02](https://kumes.github.io/BioImageDbs/inst/scripts/v02/make-data_for_v02.html)

## Information

- [Bioconductor / BioImageDbs](https://bioconductor.org/packages/release/data/experiment/html/BioImageDbs.html)

- [Package Downloads Report](http://bioconductor.org/packages/stats/data-experiment/BioImageDbs/)

## Installation

1. Start R.app

2. Run the following commands in the R console.

```r
if (!requireNamespace("BiocManager", quietly = TRUE)){ install.packages("BiocManager") }
BiocManager::install(c("ExperimentHub", "BioImageDbs"))
library(ExperimentHub)
library(BioImageDbs)

install.packages("magick")
library(magick)
```

## Simple usage

1. Search and download the image dataset.

```r
eh <- ExperimentHub()

#Data search
qr <- query(eh, c("BioImageDbs", "EM_id0001"))

#Show the metadata of EM_id0001
N <- 1
qr[N]
str(qr[N])

#Data download
ImgData <- qr[[N]]

#Show info
str(ImgData)
```

2. Display the GIF animation.

```r
qr <- query(eh, c("BioImageDbs", "EM_id0001"))

#Show info
N <- 2
qr[N]

#View
magick::image_read(qr[[N]])
```

## License

Copyright (c) 2021 Satoshi Kume released under the [Artistic License 2.0](http://www.perlfoundation.org/artistic_license_2_0).

## Cite

If any scientific publications derive from this project, you should cite:

Kume S, Nishida K (2021). BioImageDbs: Bio- and biomedical imaging dataset for machine learning and deep learning (for ExperimentHub). Bioconductor: ExperimentHub package.

```
#BibTeX
@misc{Kume2021bioc,
  title={BioImageDbs: Bio- and biomedical imaging dataset for machine learning and deep learning (for ExperimentHub)},
  author={Kume, Satoshi and Nishida, Kozo},
  year={2021},
  publisher={Bioconductor},
  note={Experiment Packages},
  howpublished={\url{https://bioconductor.org/packages/release/data/experiment/html/BioImageDbs.html}},
}
```

## Authors
- Satoshi Kume
- Kozo Nishida

####################################################################################
#An image visualization function to create an animation for the 5D array.
####################################################################################
ImageView3D <- function(ImgArray, Sample=1,
                        Lab01="Original", Lab02="Merge", Lab03="Supervised",
                        Name=paste0(DataFolder, "_train_dataset"),
                        Interval = 0.1, Dpi=72,
                        Width = 500, Height=250){
    options(EBImage.display = "raster")
    XYsize = 256
    names(ImgArray) <- c("Original", "GroundTruth")

    saveGIF({
    for(n in seq_len(dim(ImgArray$Original)[4])){
      #n <- 1
      par(bg = 'grey')
      Image_color01 <- paintObjects(resize(ImgArray$GroundTruth[Sample,,,n,], XYsize, XYsize, filter="none")/2,
                                      toRGB(resize(ImgArray$Original[Sample,,,n,], XYsize, XYsize, filter="none")), opac=c(0.25, 0.25),
                                      col=c("red","red"), thick=TRUE, closed=FALSE)
      EBImage::display(EBImage::combine(resize(toRGB(ImgArray$Original[Sample,,,n,]), XYsize, XYsize, filter="none"),
                                          resize(Image_color01, XYsize, XYsize, filter="none"),
                                          resize(toRGB(ImgArray$GroundTruth[Sample,,,n,]), XYsize, XYsize, filter="none")),
                         nx=3, all=TRUE, spacing = 0.01, margin = 70)
      text(x = XYsize*0.5, y = -XYsize*0.175,
             label = Lab01, adj = c(0,1), col = "black", cex = 1.2, pos=1, srt=0)
      text(x = XYsize*0.5+XYsize, y = -XYsize*0.175,
             label = Lab02, adj = c(0,1), col = "black", cex = 1.2, pos=1, srt=0)
      text(x = XYsize*0.5+XYsize*2, y = -XYsize*0.175,
             label = Lab03, adj = c(0,1), col = "black", cex = 1.2, pos=1, srt=0)
      text(x = XYsize*0.5+XYsize, y = XYsize + XYsize*0.05,
             label = paste("Image section: ", n),
             adj = c(0,1), col = "black", cex = 1.2, pos=1, srt=0)
    }}, movie.name = paste0(Name, ".gif"), interval = Interval, dpi=Dpi,
    nmax = dim(ImgArray$Original)[4], ani.width = Width, ani.height=Height, ani.type="png")
}

####################################################################################
#An image visualization function to create an animation for the 4D array.
####################################################################################
ImageView2D <- function(ImgArray,
                        Lab01="Original", Lab02="Merge", Lab03="Supervised",
                        Name, Interval = 0.25, Opac=c(0.2, 0.2), Dpi=72,
                        Width = 500, Height=250){
    options(EBImage.display = "raster")
    XYsize = 256
    names(ImgArray) <- c("Original", "GroundTruth")

    saveGIF({
    for(n in seq_len(dim(ImgArray$Original)[1])){
      #n <- 1
      par(bg = 'grey')
      Image_color01 <- paintObjects(resize(ImgArray$GroundTruth[n,,,], XYsize, XYsize, filter="none")/2,
                                      toRGB(resize(ImgArray$Original[n,,,], XYsize, XYsize, filter="none")), opac=Opac,
                                      col=c("red","red"), thick=TRUE, closed=FALSE)
      EBImage::display(EBImage::combine(resize(toRGB(ImgArray$Original[n,,,]), XYsize, XYsize, filter="none"),
                                          resize(Image_color01, XYsize, XYsize, filter="none"),
                                          resize(toRGB(ImgArray$GroundTruth[n,,,]), XYsize, XYsize, filter="none")),
                         nx=3, all=TRUE, spacing = 0.01, margin = 70)
      text(x = XYsize*0.5, y = -XYsize*0.175,
             label = Lab01, adj = c(0,1), col = "black", cex = 1.2, pos=1, srt=0)
      text(x = XYsize*0.5+XYsize, y = -XYsize*0.175,
             label = Lab02, adj = c(0,1), col = "black", cex = 1.2, pos=1, srt=0)
      text(x = XYsize*0.5+XYsize*2, y = -XYsize*0.175,
             label = Lab03, adj = c(0,1), col = "black", cex = 1.2, pos=1, srt=0)
      text(x = XYsize*0.5+XYsize, y = XYsize + XYsize*0.05,
             label = paste("Image section: ", n),
             adj = c(0,1), col = "black", cex = 1.2, pos=1, srt=0)
    }}, movie.name = paste0(Name, ".gif"), interval = Interval, dpi=Dpi,
    nmax = dim(ImgArray$Original)[1], ani.width = Width, ani.height=Height, ani.type="png")
}

####################################################################################
# Read and display GIF animations
####################################################################################
Display.GIF <- function(GifFileName, View=TRUE){
a <- magick::image_read(GifFileName)
if(View){print(a); return(a)}else{return(a)}
}

#NotRun
if(FALSE){
  #install the packages in Docker/Bioconductor
  getwd()
  BiocManager::install("AnnotationHub")
  BiocManager::install("ExperimentHub")
  BiocManager::install("BiocStyle")
  BiocManager::install("BiocCheck")
  install.packages(c('EBImage', 'magick', 'filesstrings', 'animation'))
  
  ##install tex/pdfLatex on Terminal window by Root User
  #sudo apt-get update
  #sudo apt-get install texlive-latex-base texlive-latex-extra texinfo
  #sudo apt-get install texlive-fonts-recommended texlive-fonts-extra
  
  library(AnnotationHub)
  library(ExperimentHub)
  
  ## install test for BioImageDbs package
  system("R CMD INSTALL BioImageDbs")
  system("R CMD build --keep-empty-dirs --no-resave-data BioImageDbs")
  system("R CMD check --no-vignettes --timings --no-multiarch BioImageDbs_0.99.3.tar.gz")
  BiocCheck::BiocCheck("./BioImageDbs_0.99.3.tar.gz")
  
}

###################################
#Check data on Bioconductor Docker
###################################

install.packages(c('BiocManager'))
BiocManager::install("ExperimentHub")
library(ExperimentHub)

eh <- ExperimentHub()
qr <- query(eh, c("BioImageDbs"))
qr

## ----style, echo = FALSE, results = 'asis', message=FALSE---------------------
BiocStyle::markdown()

## ----load-lib, message = FALSE------------------------------------------------
library(ExperimentHub)
eh <- ExperimentHub()

## ----list-BioImageDbs---------------------------------------------------------
query(eh, "BioImage")

## ----confirm-metadata---------------------------------------------------------
mcols(query(eh, "BioImage"))

## ----query-mouse--------------------------------------------------------------
qr <- query(eh, c("BioImageDbs", "LM_id0001"))
qr

#Import data
#BioImageDbs_image_Dat <- qr[[1]]

## -----------------------------------------------------------------------------
qr <- query(eh, c("BioImageDbs", ".gif"))
qr

#EM_id0001_Brain_CA1_hippocampus_region_5dTensor_train_data
qr[1]

##Display the gif image
#magick::image_read(qr[[1]])

## ----Fig001, fig.cap = "EM_id0001_Brain_CA1_hippocampus_region_5dTensor_train_dataset.gif", echo = FALSE----
#magick::image_read(qr[[1]])
options(EBImage.display = "raster")
img <- system.file("images", "EM_id0001.png", package="BioImageDbs")
EBImage::display(EBImage::readImage(files = img))

## ----Fig002, fig.cap = "EM_id0002_Drosophila_brain_region_5dTensor_train_dataset.gif", echo = FALSE----
#magick::image_read(qr[[2]])
options(EBImage.display = "raster")
img <- system.file("images", "EM_id0002.png", package="BioImageDbs")
EBImage::display(EBImage::readImage(files = img))

## ----Fig003, fig.cap = "EM_id0003_J558L_4dTensor_train_dataset.gif", echo = FALSE----
#magick::image_read(qr[[9]])
options(EBImage.display = "raster")
img <- system.file("images", "EM_id0003.png", package="BioImageDbs")
EBImage::display(EBImage::readImage(files = img))

## ----Fig004, fig.cap = "EM_id0004_PrHudata_4dTensor_train_dataset.gif", echo = FALSE----
#magick::image_read(qr[[10]])
options(EBImage.display = "raster")
img <- system.file("images", "EM_id0004.png", package="BioImageDbs")
EBImage::display(EBImage::readImage(files = img))

## ----Fig008, fig.cap = "EM_id0005_Mouse_Kidney_2D_All_Mito_1024_4dTensor_dataset.gif", echo = FALSE----
options(EBImage.display = "raster")
img <- system.file("images", "EM_id0005_Mouse_Kidney_2D_Mito.png", package="BioImageDbs")
EBImage::display(EBImage::readImage(files = img))

## ----Fig009, fig.cap = "EM_id0005_Mouse_Kidney_2D_All_Nuc_1024_4dtensor.Rds", echo = FALSE----
options(EBImage.display = "raster")
img <- system.file("images", "EM_id0005_Mouse_Kidney_2D_Nuc.png", package="BioImageDbs")
EBImage::display(EBImage::readImage(files = img))

## ----Fig010, fig.cap = "EM_id0006_Rat_Liver_2D_All_Mito_1024_4dTensor_dataset.gif", echo = FALSE----
options(EBImage.display = "raster")
img <- system.file("images", "EM_id0006_Rat_Liver_Mito.png", package="BioImageDbs")
EBImage::display(EBImage::readImage(files = img))

## ----Fig011, fig.cap = "EM_id0006_Rat_Liver_2D_All_Nuc_1024_4dTensor_dataset.gif", echo = FALSE----
options(EBImage.display = "raster")
img <- system.file("images", "EM_id0006_Rat_Liver_Nuc.png", package="BioImageDbs")
EBImage::display(EBImage::readImage(files = img))

## ----Fig012, fig.cap = "EM_id0007_Mouse_Kidney_MultiScale_All_Low_Glomerulus_1024_4dTensor_dataset.gif", echo = FALSE----
options(EBImage.display = "raster")
img <- system.file("images", "EM_id0007_Mouse_Kidney_MultiScale_Glomerulus.png", package="BioImageDbs")
EBImage::display(EBImage::readImage(files = img))

## ----Fig013, fig.cap = "EM_id0007_Mouse_Kidney_MultiScale_All_Middle_Podocyte_1024_4dTensor_dataset.gif", echo = FALSE----
options(EBImage.display = "raster")
img <- system.file("images", "EM_id0007_Mouse_Kidney_MultiScale_Podocyte.png", package="BioImageDbs")
EBImage::display(EBImage::readImage(files = img))

## ----Fig014, fig.cap = "EM_id0008_Human_NB4_2D_All_Cel_512_4dTensor_dataset.gif", echo = FALSE----
options(EBImage.display = "raster")
img <- system.file("images", "EM_id0008_Human_NB4_Nuc.png", package="BioImageDbs")
EBImage::display(EBImage::readImage(files = img))

## ----Fig015, fig.cap = "EM_id0008_Human_NB4_2D_All_Nuc_1024_4dTensor_dataset.gif", echo = FALSE----
options(EBImage.display = "raster")
img <- system.file("images", "EM_id0008_Human_NB4_Cell.png", package="BioImageDbs")
EBImage::display(EBImage::readImage(files = img))

## ----Fig016, fig.cap = "EM_id0009_MurineBMMC_All_512_4dTensor_dataset.gif", echo = FALSE----
options(EBImage.display = "raster")
img <- system.file("images", "EM_id0009.png", package="BioImageDbs")
EBImage::display(EBImage::readImage(files = img))

## ----Fig017, fig.cap = "EM_id0010_HumanBlast_All_512_4dTensor_dataset.gif", echo = FALSE----
options(EBImage.display = "raster")
img <- system.file("images", "EM_id0010.png", package="BioImageDbs")
EBImage::display(EBImage::readImage(files = img))

## ----Fig018, fig.cap = "EM_id0011_HumanJurkat_All_512_4dTensor_dataset.gif", echo = FALSE----
options(EBImage.display = "raster")
img <- system.file("images", "EM_id0011.png", package="BioImageDbs")
EBImage::display(EBImage::readImage(files = img))

## ----Fig005, fig.cap = "LM_id0001_DIC_C2DH_HeLa_4dTensor_train_dataset.gif", echo = FALSE----
#magick::image_read(qr[[3]])
options(EBImage.display = "raster")
img <- system.file("images", "LM_id0001.png", package="BioImageDbs")
EBImage::display(EBImage::readImage(files = img))

## ----Fig006, fig.cap = "LM_id0002_PhC_C2DH_U373_4dTensor_train_dataset.gif", echo = FALSE----
#magick::image_read(qr[[5]])
options(EBImage.display = "raster")
img <- system.file("images", "LM_id0002.png", package="BioImageDbs")
EBImage::display(EBImage::readImage(files = img))

## ----Fig007, fig.cap = "LM_id0003_Fluo_N2DH_GOWT1_4dTensor_train_dataset.gif", echo = FALSE----
#magick::image_read(qr[[7]])
options(EBImage.display = "raster")
img <- system.file("images", "LM_id0003.png", package="BioImageDbs")
EBImage::display(EBImage::readImage(files = img))

## -----------------------------------------------------------------------------
## Not Run ##
# qr <- query(eh, c("BioImageDbs"))
# BioImageData <- qr[[1]]
# data <- BioImageData$Train$Train_Original
# labels <- BioImageData$Train$Train_GroundTruth
# dim(data); dim(labels)
# model %>% fit( x = data, y = labels )

## ----sessionInfo, echo=FALSE--------------------------------------------------
sessionInfo()

################################################################
## Load the package
################################################################
library(EBImage)
library(magick)
library(purrr)
library(magrittr)
library(filesstrings)
library(animation)

################################################################
## Image pre-processing
################################################################
processing_2d_image_train_test <- function(file, type="png", shape, filter="bilinear",
                                           normalize=FALSE, clahe=FALSE, GammaVal=1.0){
  image <- EBImage::readImage(file, type=type)
  image <- resize(image, w = shape[1], h = shape[2], filter = filter)
  if(normalize){image <- normalize(image)}
  if(clahe){image <- clahe(image)}
  if(is.numeric(GammaVal)){image <- image^GammaVal}
  array(image, dim=c(shape[1], shape[2], shape[3]))
}

processing_2d_image_GT <- function(file, type="png", shape){
  image <- EBImage::readImage(file, type=type)
  image <- resize(image, w = shape[1], h = shape[2], filter = "none")
  array(image, dim=c(shape[1], shape[2], shape[3]))
}

################################################################
##Download image data
################################################################
#if(!dir.exists("BioImageDbs_Data")){ dir.create("BioImageDbs_Data") }
#download.file("https://gist.githubusercontent.com/kumeS/6f67b4b9085b3d2580c51b8ae4953beb/raw/8a00395c533bd8bb16a284568d82b3318b84d3a2/gdrive_download.sh", destfile="gdrive_download.sh")
#id <- c("1kxT5ebWKLJs2Z2uNuiT4mvjuSpC2RF3_",
#        "1MRdPXshHQshYszUpcLvNf-FjCkPCGdLo",
#        "1585YNfUxZ-u8MqddEZx8cD1uihGhmdmr",
#        "1JGPe_P4hV4lCTKC9lOErE6nvsZ6AqIFt",
#        "1zu_WaPHTJr04snkWNY7fM22eZHcFHjzE")
#for(n in 1:length(id00)){
#system(paste0("source gdrive_download.sh; gdrive_download ", id[n], " ./output.zip"))
#system("mv *.zip ./BioImageDbs_Data; unzip ./BioImageDbs_Data/output.zip")
#}

################################################################
## R Functions to read image files and convert them to the Rds files
## Convert images to the 5D array
################################################################
ImgDataImport_3d_seg <- function(WIDTH  = 256, HEIGHT = 256, Z=-1, CHANNELS = 1,
                       data="./BioImageDbs_Data",
                       path01="id0001_Brain_CA1_hippocampus_region",
                       path02="01_Training",
                       Original_path="OriginalData",
                       GroundTruth_path="mitochondria_GT",
                       OriginalDataOnly=FALSE){
    DataDIR <- paste0(data, "/", path01, "/", path02)
    Original_PATH = paste0(DataDIR, "/", Original_path)
    GroundTruth_PATH = paste0(DataDIR, "/", GroundTruth_path)

    SHAPE = c(WIDTH, HEIGHT, CHANNELS)

    #Original Data
    m0 <- paste0(Original_PATH, "/", dir(Original_PATH))
    m1 <- length(paste0(Original_PATH, "/", dir(Original_PATH)))
    DatX <- c()
    if(Z== -1){Z <- length(dir(m0[1]))}
    for(n in seq_len(m1)){
    ImageFileTrain = paste0(m0[n], "/", dir(m0[n]))[1:Z]
    X = map(ImageFileTrain, processing_2d_image_train_test, shape = SHAPE)
    DatX[[n]] <- simplify2array(X)
    }

    xTensor1 <- simplify2array(DatX)
    xTensor2 <- aperm(xTensor1, c(5, 1, 2, 4, 3))

    if(!OriginalDataOnly){
    #Teacher Data
    m2 <- paste0(GroundTruth_PATH, "/", dir(GroundTruth_PATH))
    m3 <- length(paste0(GroundTruth_PATH, "/", dir(GroundTruth_PATH)))
    DatY <- c()
    for(n in seq_len(m3)){
    ImageFileTrain = paste0(m2[n], "/", dir(m2[n]))[1:Z]
    Y = map(ImageFileTrain, processing_2d_image_GT, shape = SHAPE)
    DatY[[n]] <- simplify2array(Y)
    }

    yTensor1 <- simplify2array(DatY)
    yTensor2 <- aperm(yTensor1, c(5, 1, 2, 4, 3))

    Img <- list(Original=xTensor2, GroundTruth=yTensor2)
    return (Img)

    }else{
    Img <- list(Original=xTensor2)
    return (Img)
    }
}

####################################################################################
# Convert the 5D array to the .Rds file
####################################################################################
DataImport_3d_seg <- function(WIDTH = 1024, HEIGHT = 769, Z=-1, CHANNELS = 1,
                       data="./BioImageDbs_Data",
                       path01="id0001_Brain_CA1_hippocampus_region",
                       Original_path="OriginalData",
                       GroundTruth_path="mitochondria_GT",
                       OriginalDataOnlyinTest=FALSE,
                       FileName="id0001_Brain_CA1_hippocampus_region",
                       Binary=FALSE){
a <- ImgDataImport_3d_seg(WIDTH  = WIDTH, HEIGHT = HEIGHT, Z=Z, CHANNELS = CHANNELS,
                 data=data, path01=path01, path02="01_Training",
                 Original_path=Original_path, GroundTruth_path=GroundTruth_path)
#str(a)
names(a) <- c("Train_Original", "Train_GroundTruth")

if(!OriginalDataOnlyinTest){
b <- ImgDataImport_3d_seg(WIDTH  = WIDTH, HEIGHT = HEIGHT, Z=Z, CHANNELS = CHANNELS,
                 data=data, path01=path01, path02="02_Testing",
                 Original_path=Original_path, GroundTruth_path=GroundTruth_path)
#str(b)
names(b) <- c("Test_Original", "Test_GroundTruth")
}else{
b <- ImgDataImport_3d_seg(WIDTH  = WIDTH, HEIGHT = HEIGHT, Z=Z, CHANNELS = CHANNELS,
                 data=data, path01=path01, path02="02_Testing",
                 Original_path=Original_path, GroundTruth_path=GroundTruth_path,
                 OriginalDataOnly=TRUE)
#str(b)
names(b) <- c("Test_Original")
}

if(!Binary){
Img <- list(Train=a, Test=b)
saveRDS(Img, paste0(FileName, ".Rds"), compress = TRUE)
}else{
if(!OriginalDataOnlyinTest){
a$Train_GroundTruth[a$Train_GroundTruth > 0] <- 1
names(a) <- c("Train_Original", "Train_GroundTruth_Binary")

b$Test_GroundTruth[b$Test_GroundTruth > 0] <- 1
names(b) <- c("Test_Original", "Test_GroundTruth_Binary")

Img <- list(Train=a, Test=b)
saveRDS(Img, paste0(FileName, "_Binary.Rds"), compress = TRUE)
}else{
a$Train_GroundTruth[a$Train_GroundTruth > 0] <- 1
names(a) <- c("Train_Original", "Train_GroundTruth_Binary")

Img <- list(Train=a, Test=b)
saveRDS(Img, paste0(FileName, ".Rds"), compress = TRUE)
}
}
}

################################################################
## Convert images to the 4D array
################################################################
ImgDataImport_2d_seg  <- function(WIDTH = 256, HEIGHT = 256, CHANNELS = 1,
                       data="./BioImageDbs_Data",
                       path01="LM_id0001_DIC_C2DH_HeLa",
                       path02="01_Training",
                       Original_path="OriginalData",
                       GroundTruth_path="Cell_GroundTruth_8b" ){

    DataDIR <- paste0(data, "/", path01)
    Original_PATH = paste0(DataDIR, "/", path02, "/", Original_path)
    SHAPE = c(WIDTH, HEIGHT, CHANNELS)

    #01_Training
    m0 <- paste0(Original_PATH, "/", dir(Original_PATH))
    DatX <- c()

    X = map(m0, processing_2d_image_train_test, shape = SHAPE)
    #str(X)
    DatX <- simplify2array(X)
    #str(DatX)
    xTensor1 <- aperm(DatX, c(4, 1, 2, 3))
    #str(xTensor1)

    #02_Testing
    GroundTruth_PATH = paste0(DataDIR, "/", path02, "/", GroundTruth_path)
    m0 <- paste0(GroundTruth_PATH, "/", dir(GroundTruth_PATH))
    DatY <- c()

    Y = map(m0, processing_2d_image_train_test, shape = SHAPE)
    #str(Y)
    DatY <- simplify2array(Y)
    #str(DatY)
    yTensor1 <- aperm(DatY, c(4, 1, 2, 3))
    #str(yTensor1)

    Img <- list(Training=xTensor1, Test=yTensor1)
    #str(Img)

    return(Img)

}

####################################################################################
# Convert the 4D array to the .Rds file
####################################################################################
DataImport_2d_seg <- function(WIDTH = 512, HEIGHT = 512, CHANNELS = 1,
                       data="./BioImageDbs_Data",
                       path01="LM_id0001_DIC_C2DH_HeLa",
                       Original_path="OriginalData",
                       GroundTruth_path="Cell_GroundTruth_8b",
                       FileName="LM_id0001_DIC_C2DH_HeLa",
                       Binary=FALSE){
a <- ImgDataImport_2d_seg(WIDTH = WIDTH, HEIGHT = HEIGHT, CHANNELS = CHANNELS,
                       data=data,
                       path01=path01,
                       path02="01_Training",
                       Original_path=Original_path,
                       GroundTruth_path=GroundTruth_path)
names(a) <- c("Train_Original", "Train_GroundTruth")

b <- ImgDataImport_2d_seg(WIDTH = WIDTH, HEIGHT = HEIGHT, CHANNELS = CHANNELS,
                       data=data,
                       path01=path01,
                       path02="02_Testing",
                       Original_path=Original_path,
                       GroundTruth_path=GroundTruth_path)
names(b) <- c("Test_Original", "Test_GroundTruth")

if(!Binary){
Img <- list(Train=a, Test=b)
saveRDS(Img, paste0(FileName, ".Rds"), compress = TRUE)
}else{
a$Train_GroundTruth[a$Train_GroundTruth > 0] <- 1
names(a) <- c("Train_Original", "Train_GroundTruth_Binary")

b$Test_GroundTruth[b$Test_GroundTruth > 0] <- 1
names(b) <- c("Test_Original", "Test_GroundTruth_Binary")

Img <- list(Train=a, Test=b)
saveRDS(Img, paste0(FileName, "_Binary.Rds"), compress = TRUE)
}
}

## ----style, echo = FALSE, results = 'asis', message=FALSE---------------------
BiocStyle::markdown()

## ----load-lib, message = FALSE------------------------------------------------
library(ExperimentHub)
eh <- ExperimentHub()

## ----echo=TRUE, eval=TRUE-----------------------------------------------------
qr <- query(eh, c("BioImageDbs"))
qr

## ----echo=TRUE, eval=TRUE-----------------------------------------------------
#Show metadata (e.g. ah_id and title)
qr$ah_id
qr$title

## ----echo=TRUE, eval=TRUE-----------------------------------------------------
qr <- query(eh, c("BioImageDbs", "EM_id0001"))

##Show metadata
qr

##Import data
#Img_Data <- qr[[1]]
gif_Data <- qr[[2]]

#Show animation
library(magick)
magick::image_read(gif_Data)

## ----echo=TRUE, eval=TRUE-----------------------------------------------------
qr <- query(eh, c("BioImageDbs", "EM_id0002"))

##Show metadata
qr

##Import data
#Img_Data <- qr[[1]]
gif_Data <- qr[[2]]

#Show animation
magick::image_read(gif_Data)

## ----echo=TRUE, eval=TRUE-----------------------------------------------------
qr <- query(eh, c("BioImageDbs", "EM_id0003"))

##Show metadata
qr

##Import data
#Img_Data <- qr[[1]]

#Show animation
gif_Data <- qr[[2]]
magick::image_read(gif_Data)

## ----echo=TRUE, eval=TRUE-----------------------------------------------------
qr <- query(eh, c("BioImageDbs", "EM_id0004"))

##Show metadata
qr

##Import data
#Img_Data <- qr[[1]]

#Show animation
gif_Data <- qr[[2]]
magick::image_read(gif_Data)

## ----echo=TRUE, eval=TRUE-----------------------------------------------------
qr <- query(eh, c("BioImageDbs", "EM_id0005"))

##Show metadata
qr

##Import data
#Img_Data <- qr[[1]]

#Show animation
gif_Data <- qr[[2]]
magick::image_read(gif_Data)

## ----echo=TRUE, eval=TRUE-----------------------------------------------------
qr <- query(eh, c("BioImageDbs", "EM_id0006"))

##Show metadata
qr

##Import data
#Img_Data <- qr[[1]]

#Show animation
gif_Data <- qr[[2]]
magick::image_read(gif_Data)

## ----echo=TRUE, eval=TRUE-----------------------------------------------------
qr <- query(eh, c("BioImageDbs", "EM_id0007"))

##Show metadata
qr

##Import data
#Img_Data <- qr[[1]]

#Show animation
gif_Data <- qr[[2]]
magick::image_read(gif_Data)

## ----echo=TRUE, eval=TRUE-----------------------------------------------------
qr <- query(eh, c("BioImageDbs", "EM_id0008"))

##Show metadata
qr

##Import data
#Img_Data <- qr[[1]]

#Show animation
gif_Data <- qr[[2]]
magick::image_read(gif_Data)

## ----echo=TRUE, eval=TRUE-----------------------------------------------------
qr <- query(eh, c("BioImageDbs", "EM_id0009"))

##Show metadata
qr

##Import data
#Img_Data <- qr[[1]]

#Show animation
gif_Data <- qr[[2]]
magick::image_read(gif_Data)

## ----echo=TRUE, eval=TRUE-----------------------------------------------------
qr <- query(eh, c("BioImageDbs", "EM_id0010"))

##Show metadata
qr

##Import data
#Img_Data <- qr[[1]]

#Show animation
gif_Data <- qr[[2]]
magick::image_read(gif_Data)

## ----echo=TRUE, eval=TRUE-----------------------------------------------------
qr <- query(eh, c("BioImageDbs", "EM_id0011"))

##Show metadata
qr

##Import data
#Img_Data <- qr[[1]]

#Show animation
gif_Data <- qr[[2]]
magick::image_read(gif_Data)

## ----echo=TRUE, eval=TRUE-----------------------------------------------------
qr <- query(eh, c("BioImageDbs", "LM_id0001"))

##Show metadata
qr

##Import data
#Img_Data <- qr[[1]]

#Show animation
gif_Data <- qr[[2]]
magick::image_read(gif_Data)

## ----echo=TRUE, eval=TRUE-----------------------------------------------------
qr <- query(eh, c("BioImageDbs", "LM_id0002"))

##Show metadata
qr

##Import data
#Img_Data <- qr[[1]]

#Show animation
gif_Data <- qr[[2]]
magick::image_read(gif_Data)

## ----echo=TRUE, eval=TRUE-----------------------------------------------------
qr <- query(eh, c("BioImageDbs", "LM_id0003"))

##Show metadata
qr

##Import data
#Img_Data <- qr[[1]]

#Show animation
gif_Data <- qr[[2]]
magick::image_read(gif_Data)

## ----sessionInfo, echo=FALSE--------------------------------------------------
sessionInfo()

#!/bin/sh
# Usage: gdrive_download 123-abc ./output.zip
function gdrive_download () { 
  CONFIRM=$(wget --quiet --save-cookies /tmp/cookies.txt --keep-session-cookies --no-check-certificate "https://drive.google.com/uc?export=download&id=$1" -O- | sed -En 's/.*confirm=([0-9A-Za-z_]+).*/\1/p')
  wget --quiet --load-cookies /tmp/cookies.txt "https://drive.google.com/uc?export=download&confirm=$CONFIRM&id=$1" -O $2
  rm -f /tmp/cookies.txt
}

---
title: "make-data_for_v02"
author: 
- name: Satoshi Kume
  email: satoshi.kume.1984@gmail.com
date: "`r Sys.Date()`"
graphics: no
package: BioImageDbs
output:
  BiocStyle::html_document:
      toc_float: false
vignette: >
  %\VignetteIndexEntry{make-data_for_v02}
  %\VignetteEncoding{UTF-8}
  %\VignetteDepends{ExperimentHub}
  %\VignetteEngine{knitr::rmarkdown}
editor_options: 
  chunk_output_type: console
---


```{r style, echo = FALSE, results = 'asis', message=FALSE}
BiocStyle::markdown()
```

**Compiled**: `r date()`

**This script for the v02 dataset**

# Load the package

```{r echo=TRUE, eval=FALSE}
#Install
#devtools::install_github( "kumeS/BioImageDbs", force = TRUE )
library(BioImageDbs)

#Source
source(system.file("scripts", "./v02/ImgProc_for_v02.R", package="BioImageDbs"))
source(system.file("scripts", "./v02/ImageView_for_v02.R", package="BioImageDbs"))
```

# Convert the images to the array data in R

## EM_id0005_Mouse_Kidney_2D

### All_Mito_512_OriginalData / All_Mito_512_GroundTruth

```{r echo=TRUE, eval=FALSE}
#Set parameters
DataPath <- "./BioImageDbs_02_Dataset_v02"
DataFolder <- "EM_id0005_Mouse_Kidney_2D"
DataFolder_Name <- "_All_Mito_512_4dTensor"
Path01 <- "EM_id0005_Mouse_Kidney_2D"
Path02 <- "01_Training"
Original_path="All_Mito_512_OriginalData"
GroundTruth_path="All_Mito_512_GroundTruth"
WIDTH00 <- 512 ; HEIGHT00 <- 512 ; CHANNELS01 <- 1 ; CHANNELS02 <- 1

#Run the conversion
Img <- ImgDataImport_2d_seg(WIDTH = WIDTH00, HEIGHT = HEIGHT00,
                            CHANNELS01 = CHANNELS01, CHANNELS02 = CHANNELS02,
                            data=DataPath,
                            path01=Path01,
                            path02=Path02,
                            Original_path=Original_path,
                            GroundTruth_path=GroundTruth_path )
str(Img)
saveRDS(Img, paste0(DataPath, "/", DataFolder, DataFolder_Name, ".Rds") )

ImageView2D(Img, Interval=0.8, 
            Name=paste0(DataFolder, DataFolder_Name, "_dataset"))
filesstrings::file.move(files=paste0(DataFolder, DataFolder_Name, "_dataset.gif"),
                        destinations=DataPath, overwrite = TRUE)

#Metadata
Meta.Rds <- data.frame(
Title=paste0(DataFolder, DataFolder_Name, ".Rds"),
  Description="4D arrays with the single label of mitocondoria for the image segmentation. The mouse kidney section was examined in a scanning electron microscope with the detection of backscattered electron. The imaging magnification was x4000 (about 5.9 nm/px). To convert them as the Rds file, the images were resized to be 512x512 pixels during the processing.",	
  BiocVersion="3.14",
  Genome="NA",
  SourceType="PNG",
  SourceUrl="https://github.com/kumeS/BioImageDbs",
  SourceVersion="Sep 01 2021",
  Species="Mus musculus",
  TaxonomyId="10090",
  Coordinate_1_based="NA",
  DataProvider="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  Maintainer="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  RDataClass="List",
  DispatchClass="Rds",
  RDataPath=paste0("BioImageDbs/v02/", DataFolder, DataFolder_Name, ".Rds"),
  Tags="bioimage:segmentation:2D images:microscope:electron microscopy")
Meta.gif <- data.frame(
  Title=paste0(DataFolder, DataFolder_Name, "_dataset.gif"),
  Description=paste0("A animation file (.gif) of the dataset of ", paste0(DataFolder, DataFolder_Name, ".Rds")),	
  BiocVersion="3.14",
  Genome="NA",
  SourceType="PNG",
  SourceUrl="https://github.com/kumeS/BioImageDbs",
  SourceVersion="Sep 01 2021",
  Species="Mus musculus",
  TaxonomyId="10090",
  Coordinate_1_based="NA",
  DataProvider="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  Maintainer="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  RDataClass="magick-image",
  DispatchClass="FilePath",
  RDataPath=paste0("BioImageDbs/v02/", DataFolder, DataFolder_Name, "_dataset.gif"),
  Tags="bioimage:segmentation:2D images:microscope:electron microscopy")

readr::write_csv(Meta.Rds, file = paste0(DataPath, "/Metadata.csv"), append = T, col_names = F)
readr::write_csv(Meta.gif, file = paste0(DataPath, "/Metadata.csv"), append = T, col_names = F)

```

### All_Mito_1024_OriginalData / All_Mito_1024_GroundTruth

```{r echo=TRUE, eval=FALSE}
#Set parameters
DataPath <- "./BioImageDbs_02_Dataset_v02"
DataFolder_Name <- "_All_Mito_1024_4dTensor"
Path01 <- "EM_id0005_Mouse_Kidney_2D"; DataFolder <- Path01
Path02 <- "01_Training"
Original_path="All_Mito_1024_OriginalData"
GroundTruth_path="All_Mito_1024_GroundTruth"
WIDTH00 <- 1024 ; HEIGHT00 <- 1024 ; CHANNELS01 <- 1 ; CHANNELS02 <- 1

#Run the conversion
Img <- ImgDataImport_2d_seg(WIDTH = WIDTH00, HEIGHT = HEIGHT00,
                            CHANNELS01 = CHANNELS01, CHANNELS02 = CHANNELS02,
                            data=DataPath,
                            path01=Path01,
                            path02=Path02,
                            Original_path=Original_path,
                            GroundTruth_path=GroundTruth_path )
str(Img)
saveRDS(Img, paste0(DataPath, "/", DataFolder, DataFolder_Name, ".Rds") )

ImageView2D(Img, Interval=0.8, 
            Name=paste0(DataFolder, DataFolder_Name, "_dataset"))
filesstrings::file.move(files=paste0(DataFolder, DataFolder_Name, "_dataset.gif"),
                        destinations=DataPath, overwrite = TRUE)

#Metadata
Meta.Rds <- data.frame(
  Title=paste0(DataFolder, DataFolder_Name, ".Rds"),
  Description="4D arrays with the single label of mitocondoria for the image segmentation. The mouse kidney section was examined in a scanning electron microscope with the detection of backscattered electron. The imaging magnification was x4000 (about 5.9 nm/px). To convert them as the Rds file, the images were resized to be 1024x1024 pixels during the processing.",	
  BiocVersion="3.14",
  Genome="NA",
  SourceType="PNG",
  SourceUrl="https://github.com/kumeS/BioImageDbs",
  SourceVersion="Sep 01 2021",
  Species="Mus musculus",
  TaxonomyId="10090",
  Coordinate_1_based="NA",
  DataProvider="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  Maintainer="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  RDataClass="List",
  DispatchClass="Rds",
  RDataPath=paste0("BioImageDbs/v02/", DataFolder, DataFolder_Name, ".Rds"),
  Tags="bioimage:segmentation:2D images:microscope:electron microscopy")
Meta.gif <- data.frame(
  Title=paste0(DataFolder, DataFolder_Name, "_dataset.gif"),
  Description=paste0("A animation file (.gif) of the dataset of ", paste0(DataFolder, DataFolder_Name, ".Rds")),	
  BiocVersion="3.14",
  Genome="NA",
  SourceType="PNG",
  SourceUrl="https://github.com/kumeS/BioImageDbs",
  SourceVersion="Sep 01 2021",
  Species="Mus musculus",
  TaxonomyId="10090",
  Coordinate_1_based="NA",
  DataProvider="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  Maintainer="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  RDataClass="magick-image",
  DispatchClass="FilePath",
  RDataPath=paste0("BioImageDbs/v02/", DataFolder, DataFolder_Name, "_dataset.gif"),
  Tags="bioimage:segmentation:2D images:microscope:electron microscopy")

readr::write_csv(Meta.Rds, file = paste0(DataPath, "/Metadata.csv"), append = T, col_names = F)
readr::write_csv(Meta.gif, file = paste0(DataPath, "/Metadata.csv"), append = T, col_names = F)

```

### All_Nuc_1024_OriginalData / All_Nuc_1024_GroundTruth

```{r echo=TRUE, eval=FALSE}
#Set parameters
DataPath <- "./BioImageDbs_02_Dataset_v02"
DataFolder_Name <- "_All_Nuc_1024_4dTensor"
Path01 <- "EM_id0005_Mouse_Kidney_2D"; DataFolder <- Path01
Path02 <- "01_Training"
Original_path="All_Nuc_1024_OriginalData"
GroundTruth_path="All_Nuc_1024_GroundTruth"
WIDTH00 <- 1024 ; HEIGHT00 <- 1024 ; CHANNELS01 <- 1 ; CHANNELS02 <- 1

#Run the conversion
Img <- ImgDataImport_2d_seg(WIDTH = WIDTH00, HEIGHT = HEIGHT00,
                            CHANNELS01 = CHANNELS01, CHANNELS02 = CHANNELS02,
                            data=DataPath,
                            path01=Path01,
                            path02=Path02,
                            Original_path=Original_path,
                            GroundTruth_path=GroundTruth_path )
str( Img )
saveRDS(Img, paste0(DataPath, "/", DataFolder, DataFolder_Name, ".Rds") )

ImageView2D(Img, Interval=0.8, 
            Name=paste0(DataFolder, DataFolder_Name, "_dataset"))
filesstrings::file.move(files=paste0(DataFolder, DataFolder_Name, "_dataset.gif"),
                        destinations=DataPath, overwrite = TRUE)

#Metadata
Meta.Rds <- data.frame(
  Title=paste0(DataFolder, DataFolder_Name, ".Rds"),
  Description="4D arrays with the single label of nucleus for the image segmentation. The mouse kidney section was examined in a scanning electron microscope with the detection of backscattered electron. The imaging magnification was x4000 (about 5.9 nm/px). To convert them as the Rds file, the images were resized to be 1024x1024 pixels during the processing.",	
  BiocVersion="3.14",
  Genome="NA",
  SourceType="PNG",
  SourceUrl="https://github.com/kumeS/BioImageDbs",
  SourceVersion="Sep 01 2021",
  Species="Mus musculus",
  TaxonomyId="10090",
  Coordinate_1_based="NA",
  DataProvider="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  Maintainer="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  RDataClass="List",
  DispatchClass="Rds",
  RDataPath=paste0("BioImageDbs/v02/", DataFolder, DataFolder_Name, ".Rds"),
  Tags="bioimage:segmentation:2D images:microscope:electron microscopy")
Meta.gif <- data.frame(
  Title=paste0(DataFolder, DataFolder_Name, "_dataset.gif"),
  Description=paste0("A animation file (.gif) of the dataset of ", paste0(DataFolder, DataFolder_Name, ".Rds")),	
  BiocVersion="3.14",
  Genome="NA",
  SourceType="PNG",
  SourceUrl="https://github.com/kumeS/BioImageDbs",
  SourceVersion="Sep 01 2021",
  Species="Mus musculus",
  TaxonomyId="10090",
  Coordinate_1_based="NA",
  DataProvider="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  Maintainer="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  RDataClass="magick-image",
  DispatchClass="FilePath",
  RDataPath=paste0("BioImageDbs/v02/", DataFolder, DataFolder_Name, "_dataset.gif"),
  Tags="bioimage:segmentation:2D images:microscope:electron microscopy")

readr::write_csv(Meta.Rds, file = paste0(DataPath, "/Metadata.csv"), append = T, col_names = F)
readr::write_csv(Meta.gif, file = paste0(DataPath, "/Metadata.csv"), append = T, col_names = F)

```

### 03_Wide / WideEM_Mouse_Kidney_Fused_Img_126_190725cut / crop_x1024 / crop_x2048

crop_x1024: 28x23 tiles
crop_x2048: 14x11 tiles

```{r echo=TRUE, eval=FALSE}
#Set parameters
DataPath <- "./BioImageDbs_02_Dataset_v02"
Path01 <- "EM_id0005_Mouse_Kidney_2D"
Path02 <- "03_Wide/WideEM_Mouse_Kidney_Fused_Img_126_190725cut"
Original_path="crop_x1024"
GroundTruth_path="crop_x2048"
WIDTH00 <- 1024 ; HEIGHT00 <- 1024 ; CHANNELS01 <- 1 ; CHANNELS02 <- 1

#Run the conversion
Img <- ImgDataImport_2d_seg(WIDTH = WIDTH00, HEIGHT = HEIGHT00,
                            CHANNELS01 = CHANNELS01, CHANNELS02 = CHANNELS02,
                            data=DataPath,
                            path01=Path01,
                            path02=Path02,
                            Original_path=Original_path,
                            GroundTruth_path=GroundTruth_path )
names(Img) <- c(Original_path, GroundTruth_path)
str( Img )
saveRDS(Img, paste0(DataPath, "/", Path01, "_", sub("03_Wide/", "", Path02), "_4dtensor.Rds") )

#Metadata
Meta.Rds <- data.frame(
  Title=paste0(Path01, "_", sub("03_Wide/", "", Path02), "_4dtensor.Rds"),
  Description="4D arrays with non-labels for the image segmentation. The mouse kidney section was examined in a scanning electron microscope with the detection of backscattered electron. The imaging magnification was x4000 (about 5.9 nm/px). To convert them as the Rds file, the images were resized to be 1024x1024 pixels during the processing. The dataset of crop_x1024 consisted of 28 x 23 tiles. The dataset of crop_x2048 consisted of 14 x 11 tiles.",	
  BiocVersion="3.14",
  Genome="NA",
  SourceType="PNG",
  SourceUrl="https://github.com/kumeS/BioImageDbs",
  SourceVersion="Sep 01 2021",
  Species="Mus musculus",
  TaxonomyId="10090",
  Coordinate_1_based="NA",
  DataProvider="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  Maintainer="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  RDataClass="List",
  DispatchClass="Rds",
  RDataPath=paste0("BioImageDbs/v02/", Path01, "_", sub("03_Wide/", "", Path02), "_4dtensor.Rds"),
  Tags="bioimage:segmentation:2D images:microscope:electron microscopy")

readr::write_csv(Meta.Rds, file = paste0(DataPath, "/Metadata.csv"), append = T, col_names = F)

```

## EM_id0006_Rat_Liver_2D

### All_Mito_256_OriginalData / All_Mito_256_GroundTruth

```{r echo=TRUE, eval=FALSE}
#Set parameters
DataPath <- "./BioImageDbs_02_Dataset_v02"
DataFolder_Name <- "_All_Mito_256_4dTensor"
Path01 <- "EM_id0006_Rat_Liver_2D"; DataFolder <- Path01
Path02 <- "01_Training"
Original_path="All_Mito_256_OriginalData"
GroundTruth_path="All_Mito_256_GroundTruth"
WIDTH00 <- 256 ; HEIGHT00 <- 256 ; CHANNELS01 <- 1 ; CHANNELS02 <- 1

#Run the conversion
Img <- ImgDataImport_2d_seg(WIDTH = WIDTH00, HEIGHT = HEIGHT00,
                            CHANNELS01 = CHANNELS01, CHANNELS02 = CHANNELS02,
                            data=DataPath,
                            path01=Path01,
                            path02=Path02,
                            Original_path=Original_path,
                            GroundTruth_path=GroundTruth_path )
str( Img )
saveRDS(Img, paste0(DataPath, "/", DataFolder, DataFolder_Name, ".Rds") )

ImageView2D(Img, Interval=0.8, 
            Name=paste0(DataFolder, DataFolder_Name, "_dataset"))
filesstrings::file.move(files=paste0(DataFolder, DataFolder_Name, "_dataset.gif"),
                        destinations=DataPath, overwrite = TRUE)

#Metadata
Meta.Rds <- data.frame(
  Title=paste0(DataFolder, DataFolder_Name, ".Rds"),
  Description="4D arrays with the single label of mitocondoria for the image segmentation. The rat liver section was examined in a scanning electron microscope with the detection of backscattered electron. The imaging magnification was x7500 (about 12 nm/px). To convert them as the Rds file, the images were resized to be 256x256 pixels during the processing.",	
  BiocVersion="3.14",
  Genome="NA",
  SourceType="PNG",
  SourceUrl="https://github.com/kumeS/BioImageDbs",
  SourceVersion="Sep 01 2021",
  Species="Rattus norvegicus",
  TaxonomyId="10116",
  Coordinate_1_based="NA",
  DataProvider="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  Maintainer="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  RDataClass="List",
  DispatchClass="Rds",
  RDataPath=paste0("BioImageDbs/v02/", DataFolder, DataFolder_Name, ".Rds"),
  Tags="bioimage:segmentation:2D images:microscope:electron microscopy")
Meta.gif <- data.frame(
  Title=paste0(DataFolder, DataFolder_Name, "_dataset.gif"),
  Description=paste0("A animation file (.gif) of the dataset of ", paste0(DataFolder, DataFolder_Name, ".Rds")),	
  BiocVersion="3.14",
  Genome="NA",
  SourceType="PNG",
  SourceUrl="https://github.com/kumeS/BioImageDbs",
  SourceVersion="Sep 01 2021",
  Species="Rattus norvegicus",
  TaxonomyId="10116",
  Coordinate_1_based="NA",
  DataProvider="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  Maintainer="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  RDataClass="magick-image",
  DispatchClass="FilePath",
  RDataPath=paste0("BioImageDbs/v02/", DataFolder, DataFolder_Name, "_dataset.gif"),
  Tags="bioimage:segmentation:2D images:microscope:electron microscopy")

readr::write_csv(Meta.Rds, file = paste0(DataPath, "/Metadata.csv"), append = T, col_names = F)
readr::write_csv(Meta.gif, file = paste0(DataPath, "/Metadata.csv"), append = T, col_names = F)

```

### All_Mito_512_OriginalData / All_Mito_512_GroundTruth

```{r echo=TRUE, eval=FALSE}
#Set parameters
DataPath <- "./BioImageDbs_02_Dataset_v02"
DataFolder_Name <- "_All_Mito_512_4dTensor"
Path01 <- "EM_id0006_Rat_Liver_2D"; DataFolder <- Path01
Path02 <- "01_Training"
Original_path="All_Mito_512_OriginalData"
GroundTruth_path="All_Mito_512_GroundTruth"
WIDTH00 <- 512 ; HEIGHT00 <- 512 ; CHANNELS01 <- 1 ; CHANNELS02 <- 1

#Run the conversion
Img <- ImgDataImport_2d_seg(WIDTH = WIDTH00, HEIGHT = HEIGHT00,
                            CHANNELS01 = CHANNELS01, CHANNELS02 = CHANNELS02,
                            data=DataPath,
                            path01=Path01,
                            path02=Path02,
                            Original_path=Original_path,
                            GroundTruth_path=GroundTruth_path )
str( Img )
saveRDS(Img, paste0(DataPath, "/", DataFolder, DataFolder_Name, ".Rds") )

ImageView2D(Img, Interval=0.8, 
            Name=paste0(DataFolder, DataFolder_Name, "_dataset"))
filesstrings::file.move(files=paste0(DataFolder, DataFolder_Name, "_dataset.gif"),
                        destinations=DataPath, overwrite = TRUE)

#Metadata
Meta.Rds <- data.frame(
  Title=paste0(DataFolder, DataFolder_Name, ".Rds"),
  Description="4D arrays with the single label of mitocondoria for the image segmentation. The rat liver section was examined in a scanning electron microscope with the detection of backscattered electron. The imaging magnification was x7500 (about 12 nm/px). To convert them as the Rds file, the images were resized to be 512x512 pixels during the processing.",	
  BiocVersion="3.14",
  Genome="NA",
  SourceType="PNG",
  SourceUrl="https://github.com/kumeS/BioImageDbs",
  SourceVersion="Sep 01 2021",
  Species="Rattus norvegicus",
  TaxonomyId="10116",
  Coordinate_1_based="NA",
  DataProvider="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  Maintainer="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  RDataClass="List",
  DispatchClass="Rds",
  RDataPath=paste0("BioImageDbs/v02/", DataFolder, DataFolder_Name, ".Rds"),
  Tags="bioimage:segmentation:2D images:microscope:electron microscopy")
Meta.gif <- data.frame(
  Title=paste0(DataFolder, DataFolder_Name, "_dataset.gif"),
  Description=paste0("A animation file (.gif) of the dataset of ", paste0(DataFolder, DataFolder_Name, ".Rds")),	
  BiocVersion="3.14",
  Genome="NA",
  SourceType="PNG",
  SourceUrl="https://github.com/kumeS/BioImageDbs",
  SourceVersion="Sep 01 2021",
  Species="Rattus norvegicus",
  TaxonomyId="10116",
  Coordinate_1_based="NA",
  DataProvider="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  Maintainer="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  RDataClass="magick-image",
  DispatchClass="FilePath",
  RDataPath=paste0("BioImageDbs/v02/", DataFolder, DataFolder_Name, "_dataset.gif"),
  Tags="bioimage:segmentation:2D images:microscope:electron microscopy")

readr::write_csv(Meta.Rds, file = paste0(DataPath, "/Metadata.csv"), append = T, col_names = F)
readr::write_csv(Meta.gif, file = paste0(DataPath, "/Metadata.csv"), append = T, col_names = F)

```

### All_Mito_1024_OriginalData / All_Mito_1024_GroundTruth

```{r echo=TRUE, eval=FALSE}
#Set parameters
DataPath <- "./BioImageDbs_02_Dataset_v02"
DataFolder_Name <- "_All_Mito_1024_4dTensor"
Path01 <- "EM_id0006_Rat_Liver_2D"; DataFolder <- Path01
Path02 <- "01_Training"
Original_path="All_Mito_1024_OriginalData"
GroundTruth_path="All_Mito_1024_GroundTruth"
WIDTH00 <- 1024 ; HEIGHT00 <- 1024 ; CHANNELS01 <- 1 ; CHANNELS02 <- 1

#Run the conversion
Img <- ImgDataImport_2d_seg(WIDTH = WIDTH00, HEIGHT = HEIGHT00,
                            CHANNELS01 = CHANNELS01, CHANNELS02 = CHANNELS02,
                            data=DataPath,
                            path01=Path01,
                            path02=Path02,
                            Original_path=Original_path,
                            GroundTruth_path=GroundTruth_path )
str( Img )
saveRDS(Img, paste0(DataPath, "/", DataFolder, DataFolder_Name, ".Rds") )

ImageView2D(Img, Interval=0.8, 
            Name=paste0(DataFolder, DataFolder_Name, "_dataset"))
filesstrings::file.move(files=paste0(DataFolder, DataFolder_Name, "_dataset.gif"),
                        destinations=DataPath, overwrite = TRUE)

#Metadata
Meta.Rds <- data.frame(
  Title=paste0(DataFolder, DataFolder_Name, ".Rds"),
  Description="4D arrays with the single label of mitocondoria for the image segmentation. The rat liver section was examined in a scanning electron microscope with the detection of backscattered electron. The imaging magnification was x7500 (about 12 nm/px). To convert them as the Rds file, the images were resized to be 1024x1024 pixels during the processing.",	
  BiocVersion="3.14",
  Genome="NA",
  SourceType="PNG",
  SourceUrl="https://github.com/kumeS/BioImageDbs",
  SourceVersion="Sep 01 2021",
  Species="Rattus norvegicus",
  TaxonomyId="10116",
  Coordinate_1_based="NA",
  DataProvider="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  Maintainer="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  RDataClass="List",
  DispatchClass="Rds",
  RDataPath=paste0("BioImageDbs/v02/", DataFolder, DataFolder_Name, ".Rds"),
  Tags="bioimage:segmentation:2D images:microscope:electron microscopy")
Meta.gif <- data.frame(
  Title=paste0(DataFolder, DataFolder_Name, "_dataset.gif"),
  Description=paste0("A animation file (.gif) of the dataset of ", paste0(DataFolder, DataFolder_Name, ".Rds")),	
  BiocVersion="3.14",
  Genome="NA",
  SourceType="PNG",
  SourceUrl="https://github.com/kumeS/BioImageDbs",
  SourceVersion="Sep 01 2021",
  Species="Rattus norvegicus",
  TaxonomyId="10116",
  Coordinate_1_based="NA",
  DataProvider="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  Maintainer="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  RDataClass="magick-image",
  DispatchClass="FilePath",
  RDataPath=paste0("BioImageDbs/v02/", DataFolder, DataFolder_Name, "_dataset.gif"),
  Tags="bioimage:segmentation:2D images:microscope:electron microscopy")

readr::write_csv(Meta.Rds, file = paste0(DataPath, "/Metadata.csv"), append = T, col_names = F)
readr::write_csv(Meta.gif, file = paste0(DataPath, "/Metadata.csv"), append = T, col_names = F)

```

### All_Nuc_1024_OriginalData / All_Nuc_1024_GroundTruth

```{r echo=TRUE, eval=FALSE}
#Set parameters
DataPath <- "./BioImageDbs_02_Dataset_v02"
DataFolder_Name <- "_All_Nuc_1024_4dTensor"
Path01 <- "EM_id0006_Rat_Liver_2D"; DataFolder <- Path01
Path02 <- "01_Training"
Original_path="All_Nuc_1024_OriginalData"
GroundTruth_path="All_Nuc_1024_GroundTruth"
WIDTH00 <- 1024 ; HEIGHT00 <- 1024 ; CHANNELS01 <- 1 ; CHANNELS02 <- 1

#Run the conversion
Img <- ImgDataImport_2d_seg(WIDTH = WIDTH00, HEIGHT = HEIGHT00,
                            CHANNELS01 = CHANNELS01, CHANNELS02 = CHANNELS02,
                            data=DataPath,
                            path01=Path01,
                            path02=Path02,
                            Original_path=Original_path,
                            GroundTruth_path=GroundTruth_path )
str( Img )
saveRDS(Img, paste0(DataPath, "/", DataFolder, DataFolder_Name, ".Rds") )

ImageView2D(Img, Interval=0.8, 
            Name=paste0(DataFolder, DataFolder_Name, "_dataset"))
filesstrings::file.move(files=paste0(DataFolder, DataFolder_Name, "_dataset.gif"),
                        destinations=DataPath, overwrite = TRUE)

#Metadata
Meta.Rds <- data.frame(
  Title=paste0(DataFolder, DataFolder_Name, ".Rds"),
  Description="4D arrays with the single label of nucleus for the image segmentation. The rat liver section was examined in a scanning electron microscope with the detection of backscattered electron. The imaging magnification was x7500 (about 12 nm/px). To convert them as the Rds file, the images were resized to be 1024x1024 pixels during the processing.",	
  BiocVersion="3.14",
  Genome="NA",
  SourceType="PNG",
  SourceUrl="https://github.com/kumeS/BioImageDbs",
  SourceVersion="Sep 01 2021",
  Species="Rattus norvegicus",
  TaxonomyId="10116",
  Coordinate_1_based="NA",
  DataProvider="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  Maintainer="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  RDataClass="List",
  DispatchClass="Rds",
  RDataPath=paste0("BioImageDbs/v02/", DataFolder, DataFolder_Name, ".Rds"),
  Tags="bioimage:segmentation:2D images:microscope:electron microscopy")
Meta.gif <- data.frame(
  Title=paste0(DataFolder, DataFolder_Name, "_dataset.gif"),
  Description=paste0("A animation file (.gif) of the dataset of ", paste0(DataFolder, DataFolder_Name, ".Rds")),	
  BiocVersion="3.14",
  Genome="NA",
  SourceType="PNG",
  SourceUrl="https://github.com/kumeS/BioImageDbs",
  SourceVersion="Sep 01 2021",
  Species="Rattus norvegicus",
  TaxonomyId="10116",
  Coordinate_1_based="NA",
  DataProvider="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  Maintainer="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  RDataClass="magick-image",
  DispatchClass="FilePath",
  RDataPath=paste0("BioImageDbs/v02/", DataFolder, DataFolder_Name, "_dataset.gif"),
  Tags="bioimage:segmentation:2D images:microscope:electron microscopy")

readr::write_csv(Meta.Rds, file = paste0(DataPath, "/Metadata.csv"), append = T, col_names = F)
readr::write_csv(Meta.gif, file = paste0(DataPath, "/Metadata.csv"), append = T, col_names = F)

```

### 03_Wide / WideEM_Rat_Liver_NCMIR_001_160408_1_1185 / crop_x1024 / crop_x2048

crop_x1024: 82x11 tiles
crop_x2048: 41x5 tiles

```{r echo=TRUE, eval=FALSE}
#Set parameters
DataPath <- "./BioImageDbs_02_Dataset_v02"
Path01 <- "EM_id0006_Rat_Liver_2D"
Path02 <- "03_Wide/WideEM_Rat_Liver_NCMIR_001_160408_1_1185"
Original_path="crop_x1024"
GroundTruth_path="crop_x2048"
WIDTH00 <- 1024 ; HEIGHT00 <- 1024 ; CHANNELS01 <- 1 ; CHANNELS02 <- 1

#Run the conversion
Img <- ImgDataImport_2d_seg(WIDTH = WIDTH00, HEIGHT = HEIGHT00,
                            CHANNELS01 = CHANNELS01, CHANNELS02 = CHANNELS02,
                            data=DataPath,
                            path01=Path01,
                            path02=Path02,
                            Original_path=Original_path,
                            GroundTruth_path=GroundTruth_path )
names(Img) <- c(Original_path, GroundTruth_path)
str( Img )
saveRDS(Img, paste0(DataPath, "/", Path01, "_", sub("03_Wide/", "", Path02), "_4dtensor.Rds") )

#Metadata
Meta.Rds <- data.frame(
  Title=paste0(Path01, "_", sub("03_Wide/", "", Path02), "_4dtensor.Rds"),
  Description="4D arrays with non-labels for the image segmentation. The rat liver section was examined in a scanning electron microscope with the detection of backscattered electron. The imaging magnification was x7500 (about 12 nm/px). To convert them as the Rds file, the images were resized to be 1024x1024 pixels during the processing. The dataset of crop_x1024 consisted of 82 x 11 tiles. The dataset of crop_x2048 consisted of 41 x 5 tiles.",	
  BiocVersion="3.14",
  Genome="NA",
  SourceType="PNG",
  SourceUrl="https://github.com/kumeS/BioImageDbs",
  SourceVersion="Sep 01 2021",
  Species="Rattus norvegicus",
  TaxonomyId="10116",
  Coordinate_1_based="NA",
  DataProvider="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  Maintainer="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  RDataClass="List",
  DispatchClass="Rds",
  RDataPath=paste0("BioImageDbs/v02/", Path01, "_", sub("03_Wide/", "", Path02), "_4dtensor.Rds"),
  Tags="bioimage:segmentation:2D images:microscope:electron microscopy")

readr::write_csv(Meta.Rds, file = paste0(DataPath, "/Metadata.csv"), append = T, col_names = F)

```

### 03_Wide / WideEM_Rat_Liver_NCMIR_001_160408_1186_2370 / crop_x1024 / crop_x2048

crop_x1024: 82x11 tiles
crop_x2048: 41x5 tiles

```{r echo=TRUE, eval=FALSE}
#Set parameters
DataPath <- "./BioImageDbs_02_Dataset_v02"
Path01 <- "EM_id0006_Rat_Liver_2D"
Path02 <- "03_Wide/WideEM_Rat_Liver_NCMIR_001_160408_1186_2370"
Original_path="crop_x1024"
GroundTruth_path="crop_x2048"
WIDTH00 <- 1024 ; HEIGHT00 <- 1024 ; CHANNELS01 <- 1 ; CHANNELS02 <- 1

#Run the conversion
Img <- ImgDataImport_2d_seg(WIDTH = WIDTH00, HEIGHT = HEIGHT00,
                            CHANNELS01 = CHANNELS01, CHANNELS02 = CHANNELS02,
                            data=DataPath,
                            path01=Path01,
                            path02=Path02,
                            Original_path=Original_path,
                            GroundTruth_path=GroundTruth_path )
names(Img) <- c(Original_path, GroundTruth_path)
str( Img )
saveRDS(Img, paste0(DataPath, "/", Path01, "_", sub("03_Wide/", "", Path02), "_4dtensor.Rds") )

#Metadata
Meta.Rds <- data.frame(
  Title=paste0(Path01, "_", sub("03_Wide/", "", Path02), "_4dtensor.Rds"),
  Description="4D arrays with non-labels for the image segmentation. The rat liver section was examined in a scanning electron microscope with the detection of backscattered electron. The imaging magnification was x7500 (about 12 nm/px). To convert them as the Rds file, the images were resized to be 1024x1024 pixels during the processing. The dataset of crop_x1024 consisted of 82 x 11 tiles. The dataset of crop_x2048 consisted of 41 x 5 tiles.",	
  BiocVersion="3.14",
  Genome="NA",
  SourceType="PNG",
  SourceUrl="https://github.com/kumeS/BioImageDbs",
  SourceVersion="Sep 01 2021",
  Species="Rattus norvegicus",
  TaxonomyId="10116",
  Coordinate_1_based="NA",
  DataProvider="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  Maintainer="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  RDataClass="List",
  DispatchClass="Rds",
  RDataPath=paste0("BioImageDbs/v02/", Path01, "_", sub("03_Wide/", "", Path02), "_4dtensor.Rds"),
  Tags="bioimage:segmentation:2D images:microscope:electron microscopy")

readr::write_csv(Meta.Rds, file = paste0(DataPath, "/Metadata.csv"), append = T, col_names = F)

```

## EM_id0007_Mouse_Kidney_MultiScale

### All_High_Gap_OriginalData / All_High_Gap_GroundTruth

```{r echo=TRUE, eval=FALSE}
#Set parameters
DataPath <- "./BioImageDbs_02_Dataset_v02"
DataFolder_Name <- "_All_High_Gap_1024_4dTensor"
Path01 <- "EM_id0007_Mouse_Kidney_MultiScale"; DataFolder <- Path01
Path02 <- "01_Training"
Original_path="All_High_Gap_OriginalData"
GroundTruth_path="All_High_Gap_GroundTruth"
WIDTH00 <- 1024 ; HEIGHT00 <- 1024 ; CHANNELS01 <- 1 ; CHANNELS02 <- 1

#Run the conversion
Img <- ImgDataImport_2d_seg(WIDTH = WIDTH00, HEIGHT = HEIGHT00,
                            CHANNELS01 = CHANNELS01, CHANNELS02 = CHANNELS02,
                            data=DataPath,
                            path01=Path01,
                            path02=Path02,
                            Original_path=Original_path,
                            GroundTruth_path=GroundTruth_path )
str( Img )
saveRDS(Img, paste0(DataPath, "/", DataFolder, DataFolder_Name, ".Rds") )

ImageView2D(Img, Interval=0.8, 
            Name=paste0(DataFolder, DataFolder_Name, "_dataset"))
filesstrings::file.move(files=paste0(DataFolder, DataFolder_Name, "_dataset.gif"),
                        destinations=DataPath, overwrite = TRUE)

#Metadata
Meta.Rds <- data.frame(
  Title=paste0(DataFolder, DataFolder_Name, ".Rds"),
  Description="4D arrays with the single label of non-cell area for the image segmentation. The mouse kidney section was examined in a scanning electron microscope with the detection of backscattered electron. The imaging magnification was x4000 (about 5.9 nm/px). To convert them as the Rds file, the images (1000x1000 pixels) were resized to be 1024x1024 pixels during the processing.",	
  BiocVersion="3.14",
  Genome="NA",
  SourceType="PNG",
  SourceUrl="https://github.com/kumeS/BioImageDbs",
  SourceVersion="Sep 01 2021",
  Species="Mus musculus",
  TaxonomyId="10090",
  Coordinate_1_based="NA",
  DataProvider="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  Maintainer="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  RDataClass="List",
  DispatchClass="Rds",
  RDataPath=paste0("BioImageDbs/v02/", DataFolder, DataFolder_Name, ".Rds"),
  Tags="bioimage:segmentation:2D images:microscope:electron microscopy")
Meta.gif <- data.frame(
  Title=paste0(DataFolder, DataFolder_Name, "_dataset.gif"),
  Description=paste0("A animation file (.gif) of the dataset of ", paste0(DataFolder, DataFolder_Name, ".Rds")),	
  BiocVersion="3.14",
  Genome="NA",
  SourceType="PNG",
  SourceUrl="https://github.com/kumeS/BioImageDbs",
  SourceVersion="Sep 01 2021",
  Species="Mus musculus",
  TaxonomyId="10090",
  Coordinate_1_based="NA",
  DataProvider="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  Maintainer="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  RDataClass="magick-image",
  DispatchClass="FilePath",
  RDataPath=paste0("BioImageDbs/v02/", DataFolder, DataFolder_Name, "_dataset.gif"),
  Tags="bioimage:segmentation:2D images:microscope:electron microscopy")

readr::write_csv(Meta.Rds, file = paste0(DataPath, "/Metadata.csv"), append = T, col_names = F)
readr::write_csv(Meta.gif, file = paste0(DataPath, "/Metadata.csv"), append = T, col_names = F)

```

### All_High_Mitochondria_OriginalData / All_High_Mitochondria_GroundTruth

```{r echo=TRUE, eval=FALSE}
#Set parameters
DataPath <- "./BioImageDbs_02_Dataset_v02"
DataFolder_Name <- "_All_High_Mito_1024_4dTensor"
Path01 <- "EM_id0007_Mouse_Kidney_MultiScale"; DataFolder <- Path01
Path02 <- "01_Training"
Original_path="All_High_Mitochondria_OriginalData"
GroundTruth_path="All_High_Mitochondria_GroundTruth"
WIDTH00 <- 1024 ; HEIGHT00 <- 1024 ; CHANNELS01 <- 1 ; CHANNELS02 <- 1

#Run the conversion
Img <- ImgDataImport_2d_seg(WIDTH = WIDTH00, HEIGHT = HEIGHT00,
                            CHANNELS01 = CHANNELS01, CHANNELS02 = CHANNELS02,
                            data=DataPath,
                            path01=Path01,
                            path02=Path02,
                            Original_path=Original_path,
                            GroundTruth_path=GroundTruth_path )
str( Img )
saveRDS(Img, paste0(DataPath, "/", DataFolder, DataFolder_Name, ".Rds") )

ImageView2D(Img, Interval=0.8,
            Name=paste0(DataFolder, DataFolder_Name, "_dataset"))
filesstrings::file.move(files=paste0(DataFolder, DataFolder_Name, "_dataset.gif"),
                        destinations=DataPath, overwrite = TRUE)

#Metadata
Meta.Rds <- data.frame(
  Title=paste0(DataFolder, DataFolder_Name, ".Rds"),
  Description="4D arrays with the single label of mitochondria for the image segmentation. The mouse kidney section was examined in a scanning electron microscope with the detection of backscattered electron. The imaging magnification was x4000 (about 5.9 nm/px). To convert them as the Rds file, the images (1000x1000 pixels) were resized to be 1024x1024 pixels during the processing.",	
  BiocVersion="3.14",
  Genome="NA",
  SourceType="PNG",
  SourceUrl="https://github.com/kumeS/BioImageDbs",
  SourceVersion="Sep 01 2021",
  Species="Mus musculus",
  TaxonomyId="10090",
  Coordinate_1_based="NA",
  DataProvider="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  Maintainer="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  RDataClass="List",
  DispatchClass="Rds",
  RDataPath=paste0("BioImageDbs/v02/", DataFolder, DataFolder_Name, ".Rds"),
  Tags="bioimage:segmentation:2D images:microscope:electron microscopy")
Meta.gif <- data.frame(
  Title=paste0(DataFolder, DataFolder_Name, "_dataset.gif"),
  Description=paste0("A animation file (.gif) of the dataset of ", paste0(DataFolder, DataFolder_Name, ".Rds")),	
  BiocVersion="3.14",
  Genome="NA",
  SourceType="PNG",
  SourceUrl="https://github.com/kumeS/BioImageDbs",
  SourceVersion="Sep 01 2021",
  Species="Mus musculus",
  TaxonomyId="10090",
  Coordinate_1_based="NA",
  DataProvider="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  Maintainer="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  RDataClass="magick-image",
  DispatchClass="FilePath",
  RDataPath=paste0("BioImageDbs/v02/", DataFolder, DataFolder_Name, "_dataset.gif"),
  Tags="bioimage:segmentation:2D images:microscope:electron microscopy")

readr::write_csv(Meta.Rds, file = paste0(DataPath, "/Metadata.csv"), append = T, col_names = F)
readr::write_csv(Meta.gif, file = paste0(DataPath, "/Metadata.csv"), append = T, col_names = F)

```

### All_High_Nucleus_OriginalData / All_High_Nucleus_GroundTruth

```{r echo=TRUE, eval=FALSE}
#Set parameters
DataPath <- "./BioImageDbs_02_Dataset_v02"
DataFolder_Name <- "_All_High_Nuc_1024_4dTensor"
Path01 <- "EM_id0007_Mouse_Kidney_MultiScale"; DataFolder <- Path01
Path02 <- "01_Training"
Original_path="All_High_Nucleus_OriginalData"
GroundTruth_path="All_High_Nucleus_GroundTruth"
WIDTH00 <- 1024 ; HEIGHT00 <- 1024 ; CHANNELS01 <- 1 ; CHANNELS02 <- 1

#Run the conversion
Img <- ImgDataImport_2d_seg(WIDTH = WIDTH00, HEIGHT = HEIGHT00,
                            CHANNELS01 = CHANNELS01, CHANNELS02 = CHANNELS02,
                            data=DataPath,
                            path01=Path01,
                            path02=Path02,
                            Original_path=Original_path,
                            GroundTruth_path=GroundTruth_path )
str( Img )
saveRDS(Img, paste0(DataPath, "/", DataFolder, DataFolder_Name, ".Rds") )

ImageView2D(Img, Interval=0.8, 
            Name=paste0(DataFolder, DataFolder_Name, "_dataset"))
filesstrings::file.move(files=paste0(DataFolder, DataFolder_Name, "_dataset.gif"),
                        destinations=DataPath, overwrite = TRUE)

#Metadata
Meta.Rds <- data.frame(
  Title=paste0(DataFolder, DataFolder_Name, ".Rds"),
  Description="4D arrays with the single label of nucleus for the image segmentation. The mouse kidney section was examined in a scanning electron microscope with the detection of backscattered electron. The imaging magnification was x4000 (about 5.9 nm/px). To convert them as the Rds file, the images (1000x1000 pixels) were resized to be 1024x1024 pixels during the processing.",	
  BiocVersion="3.14",
  Genome="NA",
  SourceType="PNG",
  SourceUrl="https://github.com/kumeS/BioImageDbs",
  SourceVersion="Sep 01 2021",
  Species="Mus musculus",
  TaxonomyId="10090",
  Coordinate_1_based="NA",
  DataProvider="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  Maintainer="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  RDataClass="List",
  DispatchClass="Rds",
  RDataPath=paste0("BioImageDbs/v02/", DataFolder, DataFolder_Name, ".Rds"),
  Tags="bioimage:segmentation:2D images:microscope:electron microscopy")
Meta.gif <- data.frame(
  Title=paste0(DataFolder, DataFolder_Name, "_dataset.gif"),
  Description=paste0("A animation file (.gif) of the dataset of ", paste0(DataFolder, DataFolder_Name, ".Rds")),	
  BiocVersion="3.14",
  Genome="NA",
  SourceType="PNG",
  SourceUrl="https://github.com/kumeS/BioImageDbs",
  SourceVersion="Sep 01 2021",
  Species="Mus musculus",
  TaxonomyId="10090",
  Coordinate_1_based="NA",
  DataProvider="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  Maintainer="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  RDataClass="magick-image",
  DispatchClass="FilePath",
  RDataPath=paste0("BioImageDbs/v02/", DataFolder, DataFolder_Name, "_dataset.gif"),
  Tags="bioimage:segmentation:2D images:microscope:electron microscopy")

readr::write_csv(Meta.Rds, file = paste0(DataPath, "/Metadata.csv"), append = T, col_names = F)
readr::write_csv(Meta.gif, file = paste0(DataPath, "/Metadata.csv"), append = T, col_names = F)

```

### All_Middle_Fibroblast_OriginalData / All_Middle_Fibroblast_GroundTruth

```{r echo=TRUE, eval=FALSE}
#Set parameters
DataPath <- "./BioImageDbs_02_Dataset_v02"
DataFolder_Name <- "_All_Middle_Fibroblast_1024_4dTensor"
Path01 <- "EM_id0007_Mouse_Kidney_MultiScale"; DataFolder <- Path01
Path02 <- "01_Training"
Original_path="All_Middle_Fibroblast_OriginalData"
GroundTruth_path="All_Middle_Fibroblast_GroundTruth"
WIDTH00 <- 1024 ; HEIGHT00 <- 1024 ; CHANNELS01 <- 1 ; CHANNELS02 <- 1

#Run the conversion
Img <- ImgDataImport_2d_seg(WIDTH = WIDTH00, HEIGHT = HEIGHT00,
                            CHANNELS01 = CHANNELS01, CHANNELS02 = CHANNELS02,
                            data=DataPath,
                            path01=Path01,
                            path02=Path02,
                            Original_path=Original_path,
                            GroundTruth_path=GroundTruth_path )
str( Img )
saveRDS(Img, paste0(DataPath, "/", DataFolder, DataFolder_Name, ".Rds") )

ImageView2D(Img, Interval=0.8, 
            Name=paste0(DataFolder, DataFolder_Name, "_dataset"))
filesstrings::file.move(files=paste0(DataFolder, DataFolder_Name, "_dataset.gif"),
                        destinations=DataPath, overwrite = TRUE)

#Metadata
Meta.Rds <- data.frame(
  Title=paste0(DataFolder, DataFolder_Name, ".Rds"),
  Description="4D arrays with the single label of fibroblast for the image segmentation. The mouse kidney section was examined in a scanning electron microscope with the detection of backscattered electron. The imaging magnification was x4000 (about 5.9 nm/px). To convert them as the Rds file, the images (3000x3000 pixels) were resized to be 1024x1024 pixels during the processing.",	
  BiocVersion="3.14",
  Genome="NA",
  SourceType="PNG",
  SourceUrl="https://github.com/kumeS/BioImageDbs",
  SourceVersion="Sep 01 2021",
  Species="Mus musculus",
  TaxonomyId="10090",
  Coordinate_1_based="NA",
  DataProvider="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  Maintainer="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  RDataClass="List",
  DispatchClass="Rds",
  RDataPath=paste0("BioImageDbs/v02/", DataFolder, DataFolder_Name, ".Rds"),
  Tags="bioimage:segmentation:2D images:microscope:electron microscopy")
Meta.gif <- data.frame(
  Title=paste0(DataFolder, DataFolder_Name, "_dataset.gif"),
  Description=paste0("A animation file (.gif) of the dataset of ", paste0(DataFolder, DataFolder_Name, ".Rds")),	
  BiocVersion="3.14",
  Genome="NA",
  SourceType="PNG",
  SourceUrl="https://github.com/kumeS/BioImageDbs",
  SourceVersion="Sep 01 2021",
  Species="Mus musculus",
  TaxonomyId="10090",
  Coordinate_1_based="NA",
  DataProvider="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  Maintainer="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  RDataClass="magick-image",
  DispatchClass="FilePath",
  RDataPath=paste0("BioImageDbs/v02/", DataFolder, DataFolder_Name, "_dataset.gif"),
  Tags="bioimage:segmentation:2D images:microscope:electron microscopy")

readr::write_csv(Meta.Rds, file = paste0(DataPath, "/Metadata.csv"), append = T, col_names = F)
readr::write_csv(Meta.gif, file = paste0(DataPath, "/Metadata.csv"), append = T, col_names = F)

```

### All_Middle_Podocyte_OriginalData / All_Middle_Podocyte_GroundTruth

```{r echo=TRUE, eval=FALSE}
#Set parameters
DataPath <- "./BioImageDbs_02_Dataset_v02"
DataFolder_Name <- "_All_Middle_Podocyte_1024_4dTensor"
Path01 <- "EM_id0007_Mouse_Kidney_MultiScale"; DataFolder <- Path01
Path02 <- "01_Training"
Original_path="All_Middle_Podocyte_OriginalData"
GroundTruth_path="All_Middle_Podocyte_GroundTruth"
WIDTH00 <- 1024 ; HEIGHT00 <- 1024 ; CHANNELS01 <- 1 ; CHANNELS02 <- 1

#Run the conversion
Img <- ImgDataImport_2d_seg(WIDTH = WIDTH00, HEIGHT = HEIGHT00,
                            CHANNELS01 = CHANNELS01, CHANNELS02 = CHANNELS02,
                            data=DataPath,
                            path01=Path01,
                            path02=Path02,
                            Original_path=Original_path,
                            GroundTruth_path=GroundTruth_path )
str( Img )
saveRDS(Img, paste0(DataPath, "/", DataFolder, DataFolder_Name, ".Rds") )

ImageView2D(Img, Interval=0.8, 
            Name=paste0(DataFolder, DataFolder_Name, "_dataset"))
filesstrings::file.move(files=paste0(DataFolder, DataFolder_Name, "_dataset.gif"),
                        destinations=DataPath, overwrite = TRUE)

#Metadata
Meta.Rds <- data.frame(
  Title=paste0(DataFolder, DataFolder_Name, ".Rds"),
  Description="4D arrays with the single label of podocyte for the image segmentation. The mouse kidney section was examined in a scanning electron microscope with the detection of backscattered electron. The imaging magnification was x4000 (about 5.9 nm/px). To convert them as the Rds file, the images (3000x3000 pixels) were resized to be 1024x1024 pixels during the processing.",	
  BiocVersion="3.14",
  Genome="NA",
  SourceType="PNG",
  SourceUrl="https://github.com/kumeS/BioImageDbs",
  SourceVersion="Sep 01 2021",
  Species="Mus musculus",
  TaxonomyId="10090",
  Coordinate_1_based="NA",
  DataProvider="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  Maintainer="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  RDataClass="List",
  DispatchClass="Rds",
  RDataPath=paste0("BioImageDbs/v02/", DataFolder, DataFolder_Name, ".Rds"),
  Tags="bioimage:segmentation:2D images:microscope:electron microscopy")
Meta.gif <- data.frame(
  Title=paste0(DataFolder, DataFolder_Name, "_dataset.gif"),
  Description=paste0("A animation file (.gif) of the dataset of ", paste0(DataFolder, DataFolder_Name, ".Rds")),	
  BiocVersion="3.14",
  Genome="NA",
  SourceType="PNG",
  SourceUrl="https://github.com/kumeS/BioImageDbs",
  SourceVersion="Sep 01 2021",
  Species="Mus musculus",
  TaxonomyId="10090",
  Coordinate_1_based="NA",
  DataProvider="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  Maintainer="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  RDataClass="magick-image",
  DispatchClass="FilePath",
  RDataPath=paste0("BioImageDbs/v02/", DataFolder, DataFolder_Name, "_dataset.gif"),
  Tags="bioimage:segmentation:2D images:microscope:electron microscopy")

readr::write_csv(Meta.Rds, file = paste0(DataPath, "/Metadata.csv"), append = T, col_names = F)
readr::write_csv(Meta.gif, file = paste0(DataPath, "/Metadata.csv"), append = T, col_names = F)

```

### All_Low_Uriniferous_Tubule_OriginalData / All_Low_Uriniferous_Tubule_GroundTruth

```{r echo=TRUE, eval=FALSE}
#Set parameters
DataPath <- "./BioImageDbs_02_Dataset_v02"
DataFolder_Name <- "_All_Low_Uriniferous_Tubule_1024_4dTensor"
Path01 <- "EM_id0007_Mouse_Kidney_MultiScale"; DataFolder <- Path01
Path02 <- "01_Training"
Original_path="All_Low_Uriniferous_Tubule_OriginalData"
GroundTruth_path="All_Low_Uriniferous_Tubule_GroundTruth"
WIDTH00 <- 1024 ; HEIGHT00 <- 1024 ; CHANNELS01 <- 1 ; CHANNELS02 <- 1

#Run the conversion
Img <- ImgDataImport_2d_seg(WIDTH = WIDTH00, HEIGHT = HEIGHT00,
                            CHANNELS01 = CHANNELS01, CHANNELS02 = CHANNELS02,
                            data=DataPath,
                            path01=Path01,
                            path02=Path02,
                            Original_path=Original_path,
                            GroundTruth_path=GroundTruth_path )
str( Img )
saveRDS(Img, paste0(DataPath, "/", DataFolder, DataFolder_Name, ".Rds") )

ImageView2D(Img, Interval=0.8, 
            Name=paste0(DataFolder, DataFolder_Name, "_dataset"))
filesstrings::file.move(files=paste0(DataFolder, DataFolder_Name, "_dataset.gif"),
                        destinations=DataPath, overwrite = TRUE)

#Metadata
Meta.Rds <- data.frame(
  Title=paste0(DataFolder, DataFolder_Name, ".Rds"),
  Description="4D arrays with the single label of uriniferous tubule for the image segmentation. The mouse kidney section was examined in a scanning electron microscope with the detection of backscattered electron. The imaging magnification was x4000 (about 5.9 nm/px). To convert them as the Rds file, the images (10000x10000 pixels) were resized to be 1024x1024 pixels during the processing.",	
  BiocVersion="3.14",
  Genome="NA",
  SourceType="PNG",
  SourceUrl="https://github.com/kumeS/BioImageDbs",
  SourceVersion="Sep 01 2021",
  Species="Mus musculus",
  TaxonomyId="10090",
  Coordinate_1_based="NA",
  DataProvider="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  Maintainer="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  RDataClass="List",
  DispatchClass="Rds",
  RDataPath=paste0("BioImageDbs/v02/", DataFolder, DataFolder_Name, ".Rds"),
  Tags="bioimage:segmentation:2D images:microscope:electron microscopy")
Meta.gif <- data.frame(
  Title=paste0(DataFolder, DataFolder_Name, "_dataset.gif"),
  Description=paste0("A animation file (.gif) of the dataset of ", paste0(DataFolder, DataFolder_Name, ".Rds")),	
  BiocVersion="3.14",
  Genome="NA",
  SourceType="PNG",
  SourceUrl="https://github.com/kumeS/BioImageDbs",
  SourceVersion="Sep 01 2021",
  Species="Mus musculus",
  TaxonomyId="10090",
  Coordinate_1_based="NA",
  DataProvider="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  Maintainer="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  RDataClass="magick-image",
  DispatchClass="FilePath",
  RDataPath=paste0("BioImageDbs/v02/", DataFolder, DataFolder_Name, "_dataset.gif"),
  Tags="bioimage:segmentation:2D images:microscope:electron microscopy")

readr::write_csv(Meta.Rds, file = paste0(DataPath, "/Metadata.csv"), append = T, col_names = F)
readr::write_csv(Meta.gif, file = paste0(DataPath, "/Metadata.csv"), append = T, col_names = F)

```

### All_Low_Glomerulus_OriginalData / All_Low_Glomerulus_GroundTruth

```{r echo=TRUE, eval=FALSE}
#Set parameters
DataPath <- "./BioImageDbs_02_Dataset_v02"
DataFolder_Name <- "_All_Low_Glomerulus_1024_4dTensor"
Path01 <- "EM_id0007_Mouse_Kidney_MultiScale"; DataFolder <- Path01
Path02 <- "01_Training"
Original_path="All_Low_Glomerulus_OriginalData"
GroundTruth_path="All_Low_Glomerulus_GroundTruth"
WIDTH00 <- 1024 ; HEIGHT00 <- 1024 ; CHANNELS01 <- 1 ; CHANNELS02 <- 1

#Run the conversion
Img <- ImgDataImport_2d_seg(WIDTH = WIDTH00, HEIGHT = HEIGHT00,
                            CHANNELS01 = CHANNELS01, CHANNELS02 = CHANNELS02,
                            data=DataPath,
                            path01=Path01,
                            path02=Path02,
                            Original_path=Original_path,
                            GroundTruth_path=GroundTruth_path )
str( Img )
saveRDS(Img, paste0(DataPath, "/", DataFolder, DataFolder_Name, ".Rds") )

ImageView2D(Img, Interval=0.8, 
            Name=paste0(DataFolder, DataFolder_Name, "_dataset"))
filesstrings::file.move(files=paste0(DataFolder, DataFolder_Name, "_dataset.gif"),
                        destinations=DataPath, overwrite = TRUE)

#Metadata
Meta.Rds <- data.frame(
  Title=paste0(DataFolder, DataFolder_Name, ".Rds"),
  Description="4D arrays with the single label of glomerulus for the image segmentation. The mouse kidney section was examined in a scanning electron microscope with the detection of backscattered electron. The imaging magnification was x4000 (about 5.9 nm/px). To convert them as the Rds file, the images (10000x10000 pixels) were resized to be 1024x1024 pixels during the processing.",	
  BiocVersion="3.14",
  Genome="NA",
  SourceType="PNG",
  SourceUrl="https://github.com/kumeS/BioImageDbs",
  SourceVersion="Sep 01 2021",
  Species="Mus musculus",
  TaxonomyId="10090",
  Coordinate_1_based="NA",
  DataProvider="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  Maintainer="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  RDataClass="List",
  DispatchClass="Rds",
  RDataPath=paste0("BioImageDbs/v02/", DataFolder, DataFolder_Name, ".Rds"),
  Tags="bioimage:segmentation:2D images:microscope:electron microscopy")
Meta.gif <- data.frame(
  Title=paste0(DataFolder, DataFolder_Name, "_dataset.gif"),
  Description=paste0("A animation file (.gif) of the dataset of ", paste0(DataFolder, DataFolder_Name, ".Rds")),	
  BiocVersion="3.14",
  Genome="NA",
  SourceType="PNG",
  SourceUrl="https://github.com/kumeS/BioImageDbs",
  SourceVersion="Sep 01 2021",
  Species="Mus musculus",
  TaxonomyId="10090",
  Coordinate_1_based="NA",
  DataProvider="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  Maintainer="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  RDataClass="magick-image",
  DispatchClass="FilePath",
  RDataPath=paste0("BioImageDbs/v02/", DataFolder, DataFolder_Name, "_dataset.gif"),
  Tags="bioimage:segmentation:2D images:microscope:electron microscopy")

readr::write_csv(Meta.Rds, file = paste0(DataPath, "/Metadata.csv"), append = T, col_names = F)
readr::write_csv(Meta.gif, file = paste0(DataPath, "/Metadata.csv"), append = T, col_names = F)

```

## EM_id0008_Human_NB4_2D

### All_Cell512_OriginalData / All_Cell512_GroundTruth

```{r echo=TRUE, eval=FALSE}
#Set parameters
DataPath <- "./BioImageDbs_02_Dataset_v02"
DataFolder_Name <- "_All_Cel_512_4dTensor"
Path01 <- "EM_id0008_Human_NB4_2D"; DataFolder <- Path01
Path02 <- "01_Training"
Original_path="All_Cell512_OriginalData"
GroundTruth_path="All_Cell512_GroundTruth"
WIDTH00 <- 512 ; HEIGHT00 <- 512 ; CHANNELS01 <- 1 ; CHANNELS02 <- 1

#Run the conversion
Img <- ImgDataImport_2d_seg(WIDTH = WIDTH00, HEIGHT = HEIGHT00,
                            CHANNELS01 = CHANNELS01, CHANNELS02 = CHANNELS02,
                            data=DataPath,
                            path01=Path01,
                            path02=Path02,
                            Original_path=Original_path,
                            GroundTruth_path=GroundTruth_path )
str( Img )
saveRDS(Img, paste0(DataPath, "/", DataFolder, DataFolder_Name, ".Rds") )

ImageView2D(Img, Interval=0.8, 
            Name=paste0(DataFolder, DataFolder_Name, "_dataset"))
filesstrings::file.move(files=paste0(DataFolder, DataFolder_Name, "_dataset.gif"),
                        destinations=DataPath, overwrite = TRUE)

#Metadata
Meta.Rds <- data.frame(
  Title=paste0(DataFolder, DataFolder_Name, ".Rds"),
  Description="4D arrays with the single label of cell body for the image segmentation. The section of human NB-4 cell (Human Leukemia, pre B-cell, cell line) was examined in a scanning electron microscope with the detection of backscattered electron. The acceleration voltage was 6-7kV and the working distance was 4 mm. The imaging magnification was x4000 (about 5.9-11.8 nm/px). To convert them as the Rds file, the images were resized to be 512x512 pixels during the processing.",	
  BiocVersion="3.14",
  Genome="NA",
  SourceType="PNG",
  SourceUrl="https://github.com/kumeS/BioImageDbs",
  SourceVersion="Sep 01 2021",
  Species="Homo sapiens",
  TaxonomyId="9606",
  Coordinate_1_based="NA",
  DataProvider="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  Maintainer="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  RDataClass="List",
  DispatchClass="Rds",
  RDataPath=paste0("BioImageDbs/v02/", DataFolder, DataFolder_Name, ".Rds"),
  Tags="bioimage:segmentation:2D images:microscope:electron microscopy")
Meta.gif <- data.frame(
  Title=paste0(DataFolder, DataFolder_Name, "_dataset.gif"),
  Description=paste0("A animation file (.gif) of the dataset of ", paste0(DataFolder, DataFolder_Name, ".Rds")),	
  BiocVersion="3.14",
  Genome="NA",
  SourceType="PNG",
  SourceUrl="https://github.com/kumeS/BioImageDbs",
  SourceVersion="Sep 01 2021",
  Species="Homo sapiens",
  TaxonomyId="9606",
  Coordinate_1_based="NA",
  DataProvider="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  Maintainer="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  RDataClass="magick-image",
  DispatchClass="FilePath",
  RDataPath=paste0("BioImageDbs/v02/", DataFolder, DataFolder_Name, "_dataset.gif"),
  Tags="bioimage:segmentation:2D images:microscope:electron microscopy")

readr::write_csv(Meta.Rds, file = paste0(DataPath, "/Metadata.csv"), append = T, col_names = F)
readr::write_csv(Meta.gif, file = paste0(DataPath, "/Metadata.csv"), append = T, col_names = F)

```

### All_Mito512_OriginalData / All_Mito512_GroundTruth

```{r echo=TRUE, eval=FALSE}
#Set parameters
DataPath <- "./BioImageDbs_02_Dataset_v02"
DataFolder_Name <- "_All_Mito_512_4dTensor"
Path01 <- "EM_id0008_Human_NB4_2D"; DataFolder <- Path01
Path02 <- "01_Training"
Original_path="All_Mito512_OriginalData"
GroundTruth_path="All_Mito512_GroundTruth"
WIDTH00 <- 512 ; HEIGHT00 <- 512 ; CHANNELS01 <- 1 ; CHANNELS02 <- 1

#Run the conversion
Img <- ImgDataImport_2d_seg(WIDTH = WIDTH00, HEIGHT = HEIGHT00,
                            CHANNELS01 = CHANNELS01, CHANNELS02 = CHANNELS02,
                            data=DataPath,
                            path01=Path01,
                            path02=Path02,
                            Original_path=Original_path,
                            GroundTruth_path=GroundTruth_path )
str( Img )
saveRDS(Img, paste0(DataPath, "/", DataFolder, DataFolder_Name, ".Rds") )

ImageView2D(Img, Interval=0.8, 
            Name=paste0(DataFolder, DataFolder_Name, "_dataset"))
filesstrings::file.move(files=paste0(DataFolder, DataFolder_Name, "_dataset.gif"),
                        destinations=DataPath, overwrite = TRUE)

#Metadata
Meta.Rds <- data.frame(
  Title=paste0(DataFolder, DataFolder_Name, ".Rds"),
  Description="4D arrays with the single label of mitochondria for the image segmentation. The section of human NB-4 cell (Human Leukemia, pre B-cell, cell line) was examined in a scanning electron microscope with the detection of backscattered electron. The acceleration voltage was 6-7kV and the working distance was 4 mm. The imaging magnification was x4000 (about 5.9-11.8 nm/px). To convert them as the Rds file, the images were resized to be 512x512 pixels during the processing.",	
  BiocVersion="3.14",
  Genome="NA",
  SourceType="PNG",
  SourceUrl="https://github.com/kumeS/BioImageDbs",
  SourceVersion="Sep 01 2021",
  Species="Homo sapiens",
  TaxonomyId="9606",
  Coordinate_1_based="NA",
  DataProvider="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  Maintainer="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  RDataClass="List",
  DispatchClass="Rds",
  RDataPath=paste0("BioImageDbs/v02/", DataFolder, DataFolder_Name, ".Rds"),
  Tags="bioimage:segmentation:2D images:microscope:electron microscopy")
Meta.gif <- data.frame(
  Title=paste0(DataFolder, DataFolder_Name, "_dataset.gif"),
  Description=paste0("A animation file (.gif) of the dataset of ", paste0(DataFolder, DataFolder_Name, ".Rds")),	
  BiocVersion="3.14",
  Genome="NA",
  SourceType="PNG",
  SourceUrl="https://github.com/kumeS/BioImageDbs",
  SourceVersion="Sep 01 2021",
  Species="Homo sapiens",
  TaxonomyId="9606",
  Coordinate_1_based="NA",
  DataProvider="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  Maintainer="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  RDataClass="magick-image",
  DispatchClass="FilePath",
  RDataPath=paste0("BioImageDbs/v02/", DataFolder, DataFolder_Name, "_dataset.gif"),
  Tags="bioimage:segmentation:2D images:microscope:electron microscopy")

readr::write_csv(Meta.Rds, file = paste0(DataPath, "/Metadata.csv"), append = T, col_names = F)
readr::write_csv(Meta.gif, file = paste0(DataPath, "/Metadata.csv"), append = T, col_names = F)

```

### All_Nuc_crop512_OriginalData / All_Nuc_crop512_GroundTruth

```{r echo=TRUE, eval=FALSE}
#Set parameters
DataPath <- "./BioImageDbs_02_Dataset_v02"
DataFolder_Name <- "_All_Nuc_crop512_4dTensor"
Path01 <- "EM_id0008_Human_NB4_2D"; DataFolder <- Path01
Path02 <- "01_Training"
Original_path="All_Nuc_crop512_OriginalData"
GroundTruth_path="All_Nuc_crop512_GroundTruth"
WIDTH00 <- 512 ; HEIGHT00 <- 512 ; CHANNELS01 <- 1 ; CHANNELS02 <- 1

#Run the conversion
Img <- ImgDataImport_2d_seg(WIDTH = WIDTH00, HEIGHT = HEIGHT00,
                            CHANNELS01 = CHANNELS01, CHANNELS02 = CHANNELS02,
                            data=DataPath,
                            path01=Path01,
                            path02=Path02,
                            Original_path=Original_path,
                            GroundTruth_path=GroundTruth_path )
str( Img )
saveRDS(Img, paste0(DataPath, "/", DataFolder, DataFolder_Name, ".Rds") )

ImageView2D(Img, Interval=0.8, 
            Name=paste0(DataFolder, DataFolder_Name, "_dataset"))
filesstrings::file.move(files=paste0(DataFolder, DataFolder_Name, "_dataset.gif"),
                        destinations=DataPath, overwrite = TRUE)

#Metadata
Meta.Rds <- data.frame(
  Title=paste0(DataFolder, DataFolder_Name, ".Rds"),
  Description="4D arrays with the single label of nucleus for the image segmentation. The section of human NB-4 cell (Human Leukemia, pre B-cell, cell line) was examined in a scanning electron microscope with the detection of backscattered electron. The acceleration voltage was 6-7kV and the working distance was 4 mm. The imaging magnification was x4000 (about 5.9-11.8 nm/px). To convert them as the Rds file, the images were resized to be 512x512 (cropped images) pixels during the processing.",	
  BiocVersion="3.14",
  Genome="NA",
  SourceType="PNG",
  SourceUrl="https://github.com/kumeS/BioImageDbs",
  SourceVersion="Sep 01 2021",
  Species="Homo sapiens",
  TaxonomyId="9606",
  Coordinate_1_based="NA",
  DataProvider="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  Maintainer="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  RDataClass="List",
  DispatchClass="Rds",
  RDataPath=paste0("BioImageDbs/v02/", DataFolder, DataFolder_Name, ".Rds"),
  Tags="bioimage:segmentation:2D images:microscope:electron microscopy")
Meta.gif <- data.frame(
  Title=paste0(DataFolder, DataFolder_Name, "_dataset.gif"),
  Description=paste0("A animation file (.gif) of the dataset of ", paste0(DataFolder, DataFolder_Name, ".Rds")),	
  BiocVersion="3.14",
  Genome="NA",
  SourceType="PNG",
  SourceUrl="https://github.com/kumeS/BioImageDbs",
  SourceVersion="Sep 01 2021",
  Species="Homo sapiens",
  TaxonomyId="9606",
  Coordinate_1_based="NA",
  DataProvider="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  Maintainer="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  RDataClass="magick-image",
  DispatchClass="FilePath",
  RDataPath=paste0("BioImageDbs/v02/", DataFolder, DataFolder_Name, "_dataset.gif"),
  Tags="bioimage:segmentation:2D images:microscope:electron microscopy")

readr::write_csv(Meta.Rds, file = paste0(DataPath, "/Metadata.csv"), append = T, col_names = F)
readr::write_csv(Meta.gif, file = paste0(DataPath, "/Metadata.csv"), append = T, col_names = F)

```

### All_Nuc512_OriginalData / All_Nuc512_GroundTruth

```{r echo=TRUE, eval=FALSE}
#Set parameters
DataPath <- "./BioImageDbs_02_Dataset_v02"
DataFolder_Name <- "_All_Nuc_512_4dTensor"
Path01 <- "EM_id0008_Human_NB4_2D"; DataFolder <- Path01
Path02 <- "01_Training"
Original_path="All_Nuc512_OriginalData"
GroundTruth_path="All_Nuc512_GroundTruth"
WIDTH00 <- 512 ; HEIGHT00 <- 512 ; CHANNELS01 <- 1 ; CHANNELS02 <- 1

#Run the conversion
Img <- ImgDataImport_2d_seg(WIDTH = WIDTH00, HEIGHT = HEIGHT00,
                            CHANNELS01 = CHANNELS01, CHANNELS02 = CHANNELS02,
                            data=DataPath,
                            path01=Path01,
                            path02=Path02,
                            Original_path=Original_path,
                            GroundTruth_path=GroundTruth_path )
str( Img )
saveRDS(Img, paste0(DataPath, "/", DataFolder, DataFolder_Name, ".Rds") )

ImageView2D(Img, Interval=0.8, 
            Name=paste0(DataFolder, DataFolder_Name, "_dataset"))
filesstrings::file.move(files=paste0(DataFolder, DataFolder_Name, "_dataset.gif"),
                        destinations=DataPath, overwrite = TRUE)

#Metadata
Meta.Rds <- data.frame(
  Title=paste0(DataFolder, DataFolder_Name, ".Rds"),
  Description="4D arrays with the single label of nucleus for the image segmentation. The section of human NB-4 cell (Human Leukemia, pre B-cell, cell line) was examined in a scanning electron microscope with the detection of backscattered electron. The acceleration voltage was 6-7kV and the working distance was 4 mm. The imaging magnification was x4000 (about 5.9-11.8 nm/px). To convert them as the Rds file, the images were resized to be 512x512 pixels during the processing.",	
  BiocVersion="3.14",
  Genome="NA",
  SourceType="PNG",
  SourceUrl="https://github.com/kumeS/BioImageDbs",
  SourceVersion="Sep 01 2021",
  Species="Homo sapiens",
  TaxonomyId="9606",
  Coordinate_1_based="NA",
  DataProvider="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  Maintainer="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  RDataClass="List",
  DispatchClass="Rds",
  RDataPath=paste0("BioImageDbs/v02/", DataFolder, DataFolder_Name, ".Rds"),
  Tags="bioimage:segmentation:2D images:microscope:electron microscopy")
Meta.gif <- data.frame(
  Title=paste0(DataFolder, DataFolder_Name, "_dataset.gif"),
  Description=paste0("A animation file (.gif) of the dataset of ", paste0(DataFolder, DataFolder_Name, ".Rds")),	
  BiocVersion="3.14",
  Genome="NA",
  SourceType="PNG",
  SourceUrl="https://github.com/kumeS/BioImageDbs",
  SourceVersion="Sep 01 2021",
  Species="Homo sapiens",
  TaxonomyId="9606",
  Coordinate_1_based="NA",
  DataProvider="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  Maintainer="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  RDataClass="magick-image",
  DispatchClass="FilePath",
  RDataPath=paste0("BioImageDbs/v02/", DataFolder, DataFolder_Name, "_dataset.gif"),
  Tags="bioimage:segmentation:2D images:microscope:electron microscopy")

readr::write_csv(Meta.Rds, file = paste0(DataPath, "/Metadata.csv"), append = T, col_names = F)
readr::write_csv(Meta.gif, file = paste0(DataPath, "/Metadata.csv"), append = T, col_names = F)

```

### All_Nuc1024_OriginalData / All_Nuc1024_GroundTruth

```{r echo=TRUE, eval=FALSE}
#Set parameters
DataPath <- "./BioImageDbs_02_Dataset_v02"
DataFolder_Name <- "_All_Nuc_1024_4dTensor"
Path01 <- "EM_id0008_Human_NB4_2D"; DataFolder <- Path01
Path02 <- "01_Training"
Original_path="All_Nuc1024_OriginalData"
GroundTruth_path="All_Nuc1024_GroundTruth"
WIDTH00 <- 1024 ; HEIGHT00 <- 1024 ; CHANNELS01 <- 1 ; CHANNELS02 <- 1

#Run the conversion
Img <- ImgDataImport_2d_seg(WIDTH = WIDTH00, HEIGHT = HEIGHT00,
                            CHANNELS01 = CHANNELS01, CHANNELS02 = CHANNELS02,
                            data=DataPath,
                            path01=Path01,
                            path02=Path02,
                            Original_path=Original_path,
                            GroundTruth_path=GroundTruth_path )
str( Img )
saveRDS(Img, paste0(DataPath, "/", DataFolder, DataFolder_Name, ".Rds") )

ImageView2D(Img, Interval=0.8, 
            Name=paste0(DataFolder, DataFolder_Name, "_dataset"))
filesstrings::file.move(files=paste0(DataFolder, DataFolder_Name, "_dataset.gif"),
                        destinations=DataPath, overwrite = TRUE)

#Metadata
Meta.Rds <- data.frame(
  Title=paste0(DataFolder, DataFolder_Name, ".Rds"),
  Description="4D arrays with the single label of nucleus for the image segmentation. The section of human NB-4 cell (Human Leukemia, pre B-cell, cell line) was examined in a scanning electron microscope with the detection of backscattered electron. The acceleration voltage was 6-7kV and the working distance was 4 mm. The imaging magnification was x4000 (about 5.9-11.8 nm/px). To convert them as the Rds file, the images were resized to be 1024x1024 pixels during the processing.",	
  BiocVersion="3.14",
  Genome="NA",
  SourceType="PNG",
  SourceUrl="https://github.com/kumeS/BioImageDbs",
  SourceVersion="Sep 01 2021",
  Species="Homo sapiens",
  TaxonomyId="9606",
  Coordinate_1_based="NA",
  DataProvider="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  Maintainer="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  RDataClass="List",
  DispatchClass="Rds",
  RDataPath=paste0("BioImageDbs/v02/", DataFolder, DataFolder_Name, ".Rds"),
  Tags="bioimage:segmentation:2D images:microscope:electron microscopy")
Meta.gif <- data.frame(
  Title=paste0(DataFolder, DataFolder_Name, "_dataset.gif"),
  Description=paste0("A animation file (.gif) of the dataset of ", paste0(DataFolder, DataFolder_Name, ".Rds")),	
  BiocVersion="3.14",
  Genome="NA",
  SourceType="PNG",
  SourceUrl="https://github.com/kumeS/BioImageDbs",
  SourceVersion="Sep 01 2021",
  Species="Homo sapiens",
  TaxonomyId="9606",
  Coordinate_1_based="NA",
  DataProvider="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  Maintainer="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  RDataClass="magick-image",
  DispatchClass="FilePath",
  RDataPath=paste0("BioImageDbs/v02/", DataFolder, DataFolder_Name, "_dataset.gif"),
  Tags="bioimage:segmentation:2D images:microscope:electron microscopy")

readr::write_csv(Meta.Rds, file = paste0(DataPath, "/Metadata.csv"), append = T, col_names = F)
readr::write_csv(Meta.gif, file = paste0(DataPath, "/Metadata.csv"), append = T, col_names = F)

```

### 03_Wide / WideEM_NB4_097_01 / crop_x1024 / crop_x2048

crop_x1024: 40x16 tiles
crop_x2048: 20x8 tiles

```{r echo=TRUE, eval=FALSE}
#Set parameters
DataPath <- "./BioImageDbs_02_Dataset_v02"
Path01 <- "EM_id0008_Human_NB4_2D"
Path02 <- "03_Wide/WideEM_NB4_097_01"
Original_path="crop_x1024"
GroundTruth_path="crop_x2048"
WIDTH00 <- 1024 ; HEIGHT00 <- 1024 ; CHANNELS01 <- 1 ; CHANNELS02 <- 1

#Run the conversion
#Sys.setenv('R_MAX_VSIZE'=32000000000)
Img <- ImgDataImport_2d_seg(WIDTH = WIDTH00, HEIGHT = HEIGHT00,
                            CHANNELS01 = CHANNELS01, CHANNELS02 = CHANNELS02,
                            data=DataPath,
                            path01=Path01,
                            path02=Path02,
                            Original_path=Original_path,
                            GroundTruth_path=GroundTruth_path, 
                            GT=FALSE )
names(Img) <- c(Original_path, GroundTruth_path)
str( Img )
saveRDS(Img, paste0(DataPath, "/", Path01, "_", sub("03_Wide/", "", Path02), "_4dtensor.Rds") )

#Metadata
Meta.Rds <- data.frame(
  Title=paste0(Path01, "_", sub("03_Wide/", "", Path02), "_4dtensor.Rds"),
  Description="4D arrays with non-labels for the image segmentation. The section of human NB-4 cell (Human Leukemia, pre B-cell, cell line) was examined in a scanning electron microscope with the detection of backscattered electron. The acceleration voltage was 6kV and the working distance was 4 mm. The imaging magnification was x4000 (about 11.8 nm/px). To convert them as the Rds file, the images were resized to be 1024x1024 pixels during the processing. The dataset of crop_x1024 consisted of 40 x 16 tiles. The dataset of crop_x2048 consisted of 20 x 8 tiles.",	
  BiocVersion="3.14",
  Genome="NA",
  SourceType="PNG",
  SourceUrl="https://github.com/kumeS/BioImageDbs",
  SourceVersion="Sep 01 2021",
  Species="Homo sapiens",
  TaxonomyId="9606",
  Coordinate_1_based="NA",
  DataProvider="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  Maintainer="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  RDataClass="List",
  DispatchClass="Rds",
  RDataPath=paste0("BioImageDbs/v02/", Path01, "_", sub("03_Wide/", "", Path02), "_4dtensor.Rds"),
  Tags="bioimage:segmentation:2D images:microscope:electron microscopy")

readr::write_csv(Meta.Rds, file = paste0(DataPath, "/Metadata.csv"), append = T, col_names = F)

```

### 03_Wide / WideEM_NB4_097_02 / crop_x1024 / crop_x2048

crop_x1024: 40x15 tiles
crop_x2048: 20x7 tiles

```{r echo=TRUE, eval=FALSE}
#Set parameters
DataPath <- "./BioImageDbs_02_Dataset_v02"
Path01 <- "EM_id0008_Human_NB4_2D"
Path02 <- "03_Wide/WideEM_NB4_097_02"
Original_path="crop_x1024"
GroundTruth_path="crop_x2048"
WIDTH00 <- 1024 ; HEIGHT00 <- 1024 ; CHANNELS01 <- 1 ; CHANNELS02 <- 1

#Run the conversion
#Sys.setenv('R_MAX_VSIZE'=32000000000)
Img <- ImgDataImport_2d_seg(WIDTH = WIDTH00, HEIGHT = HEIGHT00,
                            CHANNELS01 = CHANNELS01, CHANNELS02 = CHANNELS02,
                            data=DataPath,
                            path01=Path01,
                            path02=Path02,
                            Original_path=Original_path,
                            GroundTruth_path=GroundTruth_path, 
                            GT=FALSE )
names(Img) <- c(Original_path, GroundTruth_path)
str( Img )
saveRDS(Img, paste0(DataPath, "/", Path01, "_", sub("03_Wide/", "", Path02), "_4dtensor.Rds") )

#Metadata
Meta.Rds <- data.frame(
  Title=paste0(Path01, "_", sub("03_Wide/", "", Path02), "_4dtensor.Rds"),
  Description="4D arrays with non-labels for the image segmentation. The section of human NB-4 cell (Human Leukemia, pre B-cell, cell line) was examined in a scanning electron microscope with the detection of backscattered electron. The acceleration voltage was 6kV and the working distance was 4 mm. The imaging magnification was x4000 (about 11.8 nm/px). To convert them as the Rds file, the images were resized to be 1024x1024 pixels during the processing. The dataset of crop_x1024 consisted of 40 x 15 tiles. The dataset of crop_x2048 consisted of 20 x 7 tiles.",	
  BiocVersion="3.14",
  Genome="NA",
  SourceType="PNG",
  SourceUrl="https://github.com/kumeS/BioImageDbs",
  SourceVersion="Sep 01 2021",
  Species="Homo sapiens",
  TaxonomyId="9606",
  Coordinate_1_based="NA",
  DataProvider="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  Maintainer="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  RDataClass="List",
  DispatchClass="Rds",
  RDataPath=paste0("BioImageDbs/v02/", Path01, "_", sub("03_Wide/", "", Path02), "_4dtensor.Rds"),
  Tags="bioimage:segmentation:2D images:microscope:electron microscopy")

readr::write_csv(Meta.Rds, file = paste0(DataPath, "/Metadata.csv"), append = T, col_names = F)

```

### 03_Wide / WideEM_NB4_127 / crop_x1024 / crop_x2048

convert FusedImg_127_190725_HumanNB4_forDL_X7Y8_x4000_O15.png -crop 1024x1024 WideEM_x1024-%04d.png

convert FusedImg_127_190725_HumanNB4_forDL_X7Y8_x4000_O15.png -crop 2048x2048 WideEM_x2048-%04d.png

crop_x1024: 15x12 tiles
crop_x2048: 7x6 tiles

```{r echo=TRUE, eval=FALSE}
#Set parameters
DataPath <- "./BioImageDbs_02_Dataset_v02"
Path01 <- "EM_id0008_Human_NB4_2D"
Path02 <- "03_Wide/WideEM_NB4_127"
Original_path="crop_x1024"
GroundTruth_path="crop_x2048"
WIDTH00 <- 1024 ; HEIGHT00 <- 1024 ; CHANNELS01 <- 1 ; CHANNELS02 <- 1

#Run the conversion
#Sys.setenv('R_MAX_VSIZE'=32000000000)
Img <- ImgDataImport_2d_seg(WIDTH = WIDTH00, HEIGHT = HEIGHT00,
                            CHANNELS01 = CHANNELS01, CHANNELS02 = CHANNELS02,
                            data=DataPath,
                            path01=Path01,
                            path02=Path02,
                            Original_path=Original_path,
                            GroundTruth_path=GroundTruth_path, 
                            GT=FALSE )
names(Img) <- c(Original_path, GroundTruth_path)
str( Img )
saveRDS(Img, paste0(DataPath, "/", Path01, "_", sub("03_Wide/", "", Path02), "_4dtensor.Rds") )

#Metadata
Meta.Rds <- data.frame(
  Title=paste0(Path01, "_", sub("03_Wide/", "", Path02), "_4dtensor.Rds"),
  Description="4D arrays with non-labels for the image segmentation. The section of human NB-4 cell (Human Leukemia, pre B-cell, cell line) was examined in a scanning electron microscope with the detection of backscattered electron. The acceleration voltage was 6kV and the working distance was 4 mm. The imaging magnification was x4000 (about 5.9 nm/px). To convert them as the Rds file, the images were resized to be 1024x1024 pixels during the processing. The dataset of crop_x1024 consisted of 15 x 12 tiles. The dataset of crop_x2048 consisted of 7 x 6 tiles.",	
  BiocVersion="3.14",
  Genome="NA",
  SourceType="PNG",
  SourceUrl="https://github.com/kumeS/BioImageDbs",
  SourceVersion="Sep 01 2021",
  Species="Homo sapiens",
  TaxonomyId="9606",
  Coordinate_1_based="NA",
  DataProvider="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  Maintainer="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  RDataClass="List",
  DispatchClass="Rds",
  RDataPath=paste0("BioImageDbs/v02/", Path01, "_", sub("03_Wide/", "", Path02), "_4dtensor.Rds"),
  Tags="bioimage:segmentation:2D images:microscope:electron microscopy")

readr::write_csv(Meta.Rds, file = paste0(DataPath, "/Metadata.csv"), append = T, col_names = F)

```

## EM_id0009_MurineBMMC

### All_OriginalData / All_GroundTruth

```{r echo=TRUE, eval=FALSE}
#Set parameters
DataPath <- "./BioImageDbs_02_Dataset_v02"
DataFolder_Name <- "_All_512_4dTensor"
Path01 <- "EM_id0009_MurineBMMC"; DataFolder <- Path01
Path02 <- "01_Training"
Original_path="All_OriginalData"
GroundTruth_path="All_GroundTruth"
WIDTH00 <- 512 ; HEIGHT00 <- 512 ; CHANNELS01 <- 1 ; CHANNELS02 <- 1

#Convert TIF to PNG
if(F){
path <- paste0(DataPath, "/", DataFolder, "/01_Training/", Original_path)
Img <- dir(path, pattern=".tif")
for(n in 1:length(Img)){
  #n <- 1
  Img00 <- EBImage::readImage(paste0(path, "/", Img[n]), type="tiff")
  EBImage::writeImage(Img00, files = paste0(path, "/", sub(".tif$", ".png", Img[n])), type="png")
}
path <- paste0(DataPath, "/", DataFolder, "/01_Training/", GroundTruth_path)
Img <- dir(path, pattern=".tif")
for(n in 1:length(Img)){
  #n <- 1
  Img00 <- EBImage::readImage(paste0(path, "/", Img[n]), type="tiff")
  EBImage::writeImage(Img00, files = paste0(path, "/", sub(".tif$", ".png", Img[n])), type="png")
}
path <- paste0(DataPath, "/", DataFolder, "/02_Testing/", Original_path)
Img <- dir(path, pattern=".tif")
for(n in 1:length(Img)){
  #n <- 1
  Img00 <- EBImage::readImage(paste0(path, "/", Img[n]), type="tiff")
  EBImage::writeImage(Img00, files = paste0(path, "/", sub(".tif$", ".png", Img[n])), type="png")
}
path <- paste0(DataPath, "/", DataFolder, "/02_Testing/", GroundTruth_path)
Img <- dir(path, pattern=".tif")
for(n in 1:length(Img)){
  #n <- 1
  Img00 <- EBImage::readImage(paste0(path, "/", Img[n]), type="tiff")
  EBImage::writeImage(Img00, files = paste0(path, "/", sub(".tif$", ".png", Img[n])), type="png")
}
}

#Run the conversion
Img <- ImgDataImport_2d_seg(WIDTH = WIDTH00, HEIGHT = HEIGHT00,
                            CHANNELS01 = CHANNELS01, CHANNELS02 = CHANNELS02,
                            data=DataPath,
                            path01=Path01,
                            path02=Path02,
                            Original_path=Original_path,
                            GroundTruth_path=GroundTruth_path)
str( Img )
saveRDS(Img, paste0(DataPath, "/", DataFolder, DataFolder_Name, ".Rds") )

ImageView2D(Img, Interval=0.8, 
            Name=paste0(DataFolder, DataFolder_Name, "_dataset"))
filesstrings::file.move(files=paste0(DataFolder, DataFolder_Name, "_dataset.gif"),
                        destinations=DataPath, overwrite = TRUE)

#Metadata
Meta.Rds <- data.frame(
  Title=paste0(DataFolder, DataFolder_Name, ".Rds"),
  Description="4D arrays with the multi-labels for the image segmentation. The section of murine bone marrow derived-mast cells was examined in a Philips/FEI CM10 (80 kV) electron microscope equipped with a Bio-scan Camera Model 792. Images were recorded with Digital Micrograph softwwere (Gatan). To convert them as the Rds file, the images were resized to be 512x512 pixels during the processing.",	
  BiocVersion="3.14",
  Genome="NA",
  SourceType="PNG",
  SourceUrl="https://github.com/kumeS/BioImageDbs",
  SourceVersion="Mar 10 2011",
  Species="Mus musculus",
  TaxonomyId="10090",
  Coordinate_1_based="NA",
  DataProvider="Pattern Recognition and Image Processing, University of Freiburg. (https://lmb.informatik.uni-freiburg.de/resources/datasets/tem.en.html)",
  Maintainer="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  RDataClass="List",
  DispatchClass="Rds",
  RDataPath=paste0("BioImageDbs/v02/", DataFolder, DataFolder_Name, ".Rds"),
  Tags="bioimage:segmentation:2D images:microscope:electron microscopy")
Meta.gif <- data.frame(
  Title=paste0(DataFolder, DataFolder_Name, "_dataset.gif"),
  Description=paste0("A animation file (.gif) of the dataset of ", paste0(DataFolder, DataFolder_Name, ".Rds")),	
  BiocVersion="3.14",
  Genome="NA",
  SourceType="PNG",
  SourceUrl="https://github.com/kumeS/BioImageDbs",
  SourceVersion="Mar 10 2011",
  Species="Mus musculus",
  TaxonomyId="10090",
  Coordinate_1_based="NA",
  DataProvider="Pattern Recognition and Image Processing, University of Freiburg. (https://lmb.informatik.uni-freiburg.de/resources/datasets/tem.en.html)",
  Maintainer="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  RDataClass="magick-image",
  DispatchClass="FilePath",
  RDataPath=paste0("BioImageDbs/v02/", DataFolder, DataFolder_Name, "_dataset.gif"),
  Tags="bioimage:segmentation:2D images:microscope:electron microscopy")

readr::write_csv(Meta.Rds, file = paste0(DataPath, "/Metadata.csv"), append = T, col_names = F)
readr::write_csv(Meta.gif, file = paste0(DataPath, "/Metadata.csv"), append = T, col_names = F)

```

## EM_id0010_HumanBlast

### All_OriginalData / All_GroundTruth

```{r echo=TRUE, eval=FALSE}
#Set parameters
DataPath <- "./BioImageDbs_02_Dataset_v02"
DataFolder_Name <- "_All_512_4dTensor"
Path01 <- "EM_id0010_HumanBlast"; DataFolder <- Path01
Path02 <- "01_Training"
Original_path="All_OriginalData"
GroundTruth_path="All_GroundTruth"
WIDTH00 <- 512 ; HEIGHT00 <- 512 ; CHANNELS01 <- 1 ; CHANNELS02 <- 1

#Convert TIF to PNG
if(F){
path <- paste0(DataPath, "/", DataFolder, "/01_Training/", Original_path)
Img <- dir(path, pattern=".tif")
for(n in 1:length(Img)){
  #n <- 1
  Img00 <- EBImage::readImage(paste0(path, "/", Img[n]), type="tiff")
  EBImage::writeImage(Img00, files = paste0(path, "/", sub(".tif$", ".png", Img[n])), type="png")
}
path <- paste0(DataPath, "/", DataFolder, "/01_Training/", GroundTruth_path)
Img <- dir(path, pattern=".tif")
for(n in 1:length(Img)){
  #n <- 1
  Img00 <- EBImage::readImage(paste0(path, "/", Img[n]), type="tiff")
  EBImage::writeImage(Img00, files = paste0(path, "/", sub(".tif$", ".png", Img[n])), type="png")
}
}

#Run the conversion
Img <- ImgDataImport_2d_seg(WIDTH = WIDTH00, HEIGHT = HEIGHT00,
                            CHANNELS01 = CHANNELS01, CHANNELS02 = CHANNELS02,
                            data=DataPath,
                            path01=Path01,
                            path02=Path02,
                            Original_path=Original_path,
                            GroundTruth_path=GroundTruth_path)
str( Img )
saveRDS(Img, paste0(DataPath, "/", DataFolder, DataFolder_Name, ".Rds") )

ImageView2D(Img, Interval=0.8, 
            Name=paste0(DataFolder, DataFolder_Name, "_dataset"))
filesstrings::file.move(files=paste0(DataFolder, DataFolder_Name, "_dataset.gif"),
                        destinations=DataPath, overwrite = TRUE)

#Metadata
Meta.Rds <- data.frame(
  Title=paste0(DataFolder, DataFolder_Name, ".Rds"),
  Description="4D arrays with the multi-labels for the image segmentation. The section of primary human T cells from blood of a healthy donor and phytohemagglutinin/IL-2 expanded human T cells (T cell blasts) was examined in a Philips/FEI CM10 (80 kV) electron microscope equipped with a Bio-scan Camera Model 792. Images were recorded with Digital Micrograph softwwere (Gatan). The imaging magnification was x5800. To convert them as the Rds file, the images were resized to be 512x512 pixels during the processing.",	
  BiocVersion="3.14",
  Genome="NA",
  SourceType="PNG",
  SourceUrl="https://github.com/kumeS/BioImageDbs",
  SourceVersion="Aug 27 2011",
  Species="Homo sapiens",
  TaxonomyId="9606",
  Coordinate_1_based="NA",
  DataProvider="Pattern Recognition and Image Processing, University of Freiburg. (https://lmb.informatik.uni-freiburg.de/resources/datasets/tem.en.html)",
  Maintainer="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  RDataClass="List",
  DispatchClass="Rds",
  RDataPath=paste0("BioImageDbs/v02/", DataFolder, DataFolder_Name, ".Rds"),
  Tags="bioimage:segmentation:2D images:microscope:electron microscopy")
Meta.gif <- data.frame(
  Title=paste0(DataFolder, DataFolder_Name, "_dataset.gif"),
  Description=paste0("A animation file (.gif) of the dataset of ", paste0(DataFolder, DataFolder_Name, ".Rds")),	
  BiocVersion="3.14",
  Genome="NA",
  SourceType="PNG",
  SourceUrl="https://github.com/kumeS/BioImageDbs",
  SourceVersion="Aug 27 2011",
  Species="Homo sapiens",
  TaxonomyId="9606",
  Coordinate_1_based="NA",
  DataProvider="Pattern Recognition and Image Processing, University of Freiburg. (https://lmb.informatik.uni-freiburg.de/resources/datasets/tem.en.html)",
  Maintainer="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  RDataClass="magick-image",
  DispatchClass="FilePath",
  RDataPath=paste0("BioImageDbs/v02/", DataFolder, DataFolder_Name, "_dataset.gif"),
  Tags="bioimage:segmentation:2D images:microscope:electron microscopy")

readr::write_csv(Meta.Rds, file = paste0(DataPath, "/Metadata.csv"), append = T, col_names = F)
readr::write_csv(Meta.gif, file = paste0(DataPath, "/Metadata.csv"), append = T, col_names = F)

```

## EM_id0011_HumanJurkat

### All_OriginalData / All_GroundTruth

```{r echo=TRUE, eval=FALSE}
#Set parameters
DataPath <- "./BioImageDbs_02_Dataset_v02"
DataFolder_Name <- "_All_512_4dTensor"
Path01 <- "EM_id0011_HumanJurkat"; DataFolder <- Path01
Path02 <- "01_Training"
Original_path="All_OriginalData"
GroundTruth_path="All_GroundTruth"
WIDTH00 <- 512 ; HEIGHT00 <- 512 ; CHANNELS01 <- 1 ; CHANNELS02 <- 1

#Convert TIF to PNG
if(F){
path <- paste0(DataPath, "/", DataFolder, "/01_Training/", Original_path)
Img <- dir(path, pattern=".tif")
for(n in 1:length(Img)){
  #n <- 1
  Img00 <- EBImage::readImage(paste0(path, "/", Img[n]), type="tiff")
  EBImage::writeImage(Img00, files = paste0(path, "/", sub(".tif$", ".png", Img[n])), type="png")
}
path <- paste0(DataPath, "/", DataFolder, "/01_Training/", GroundTruth_path)
Img <- dir(path, pattern=".tif")
for(n in 1:length(Img)){
  #n <- 1
  Img00 <- EBImage::readImage(paste0(path, "/", Img[n]), type="tiff")
  EBImage::writeImage(Img00, files = paste0(path, "/", sub(".tif$", ".png", Img[n])), type="png")
}
}

#Run the conversion
Img <- ImgDataImport_2d_seg(WIDTH = WIDTH00, HEIGHT = HEIGHT00,
                            CHANNELS01 = CHANNELS01, CHANNELS02 = CHANNELS02,
                            data=DataPath,
                            path01=Path01,
                            path02=Path02,
                            Original_path=Original_path,
                            GroundTruth_path=GroundTruth_path)
str( Img )
saveRDS(Img, paste0(DataPath, "/", DataFolder, DataFolder_Name, ".Rds") )

ImageView2D(Img, Interval=0.8, 
            Name=paste0(DataFolder, DataFolder_Name, "_dataset"))
filesstrings::file.move(files=paste0(DataFolder, DataFolder_Name, "_dataset.gif"),
                        destinations=DataPath, overwrite = TRUE)

#Metadata
Meta.Rds <- data.frame(
  Title=paste0(DataFolder, DataFolder_Name, ".Rds"),
  Description="4D arrays with the multi-labels for the image segmentation. The section of human T-cell line Jurkat was examined in a Philips/FEI CM10 (80 kV) electron microscope equipped with a Bio-scan Camera Model 792. Images were recorded with Digital Micrograph softwwere (Gatan). The imaging magnification was x4600. To convert them as the Rds file, the images were resized to be 512x512 pixels during the processing.",	
  BiocVersion="3.14",
  Genome="NA",
  SourceType="PNG",
  SourceUrl="https://github.com/kumeS/BioImageDbs",
  SourceVersion="Mar 10 2011",
  Species="Homo sapiens",
  TaxonomyId="9606",
  Coordinate_1_based="NA",
  DataProvider="Pattern Recognition and Image Processing, University of Freiburg. (https://lmb.informatik.uni-freiburg.de/resources/datasets/tem.en.html)",
  Maintainer="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  RDataClass="List",
  DispatchClass="Rds",
  RDataPath=paste0("BioImageDbs/v02/", DataFolder, DataFolder_Name, ".Rds"),
  Tags="bioimage:segmentation:2D images:microscope:electron microscopy")
Meta.gif <- data.frame(
  Title=paste0(DataFolder, DataFolder_Name, "_dataset.gif"),
  Description=paste0("A animation file (.gif) of the dataset of ", paste0(DataFolder, DataFolder_Name, ".Rds")),	
  BiocVersion="3.14",
  Genome="NA",
  SourceType="PNG",
  SourceUrl="https://github.com/kumeS/BioImageDbs",
  SourceVersion="Mar 10 2011",
  Species="Homo sapiens",
  TaxonomyId="9606",
  Coordinate_1_based="NA",
  DataProvider="Pattern Recognition and Image Processing, University of Freiburg. (https://lmb.informatik.uni-freiburg.de/resources/datasets/tem.en.html)",
  Maintainer="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  RDataClass="magick-image",
  DispatchClass="FilePath",
  RDataPath=paste0("BioImageDbs/v02/", DataFolder, DataFolder_Name, "_dataset.gif"),
  Tags="bioimage:segmentation:2D images:microscope:electron microscopy")

readr::write_csv(Meta.Rds, file = paste0(DataPath, "/Metadata.csv"), append = T, col_names = F)
readr::write_csv(Meta.gif, file = paste0(DataPath, "/Metadata.csv"), append = T, col_names = F)

```

---
title: "make-data_for_v01"
author: 
- name: Satoshi Kume
  email: satoshi.kume.1984@gmail.com
date: "`r Sys.Date()`"
graphics: no
package: BioImageDbs
output:
  BiocStyle::html_document:
      toc_float: false
vignette: >
  %\VignetteIndexEntry{make-data_for_v02}
  %\VignetteEncoding{UTF-8}
  %\VignetteDepends{ExperimentHub}
  %\VignetteEngine{knitr::rmarkdown}
editor_options: 
  chunk_output_type: console
---


```{r style, echo = FALSE, results = 'asis', message=FALSE}
BiocStyle::markdown()
```

**Compiled**: `r date()`

**This script for the v01 dataset**

# Load the package

```{r echo=TRUE, eval=FALSE}
#Install
#devtools::install_github( "kumeS/BioImageDbs", force = TRUE )
library(BioImageDbs)
library(EBImage)
library(magick)
library(purrr)
library(magrittr)
library(filesstrings)
library(animation)

```

# Convert the images to the array data in R

## EM_id0001_Brain_CA1_hippocampus_region

```{r echo=TRUE, eval=FALSE}
#Set parameters
DataFolder <- "EM_id0001_Brain_CA1_hippocampus_region"
Ori <- "OriginalData"
GT <- "mitochondria_GT"
WIDTH00 <- 1024; HEIGHT00 <- 768; CHANNELS00 <- 1

#Run the conversion
DataImport_3d_seg(WIDTH = WIDTH00, HEIGHT = HEIGHT00, Z=-1, CHANNELS = CHANNELS00,
           data="./BioImageDbs_Data",
           path01=DataFolder,
           Original_path=Ori,
           GroundTruth_path=GT,
           FileName=paste0(DataFolder, "_5dTensor"))

filesstrings::file.move(files=paste0(DataFolder, "_5dTensor.Rds"),
                        destinations="./BioImageDbs_Output",
                        overwrite = TRUE)

Dat <- readRDS( paste0("./BioImageDbs_Output/", DataFolder, "_5dTensor.Rds") )
#str(Dat); str(Dat$Train)
for(n in 1:dim(Dat$Train$Train_Original)[1]){
Sample <- paste0(DataFolder, "_5dTensor_train_dataset_",  n)
ImageView3D(Dat$Train, Name=, Sample=n, Interval = 0.5)
filesstrings::file.move(files=paste0(Sample, ".gif"), destinations="./DL_analysis_v01",
                        overwrite = TRUE)
}

```

## EM_id0002_Drosophila_brain_region

```{r echo=TRUE, eval=FALSE}
#Set parameters
DataFolder <- "EM_id0002_Drosophila_brain_region"
WIDTH00 <- 512; HEIGHT00 <- 512; CHANNELS00 <- 1

#Run the conversion
DataImport_3d_seg(WIDTH = WIDTH00, HEIGHT = HEIGHT00, Z=-1, CHANNELS = CHANNELS00,
           data="./BioImageDbs_Data",
           path01=DataFolder,
           Original_path="OriginalData",
           GroundTruth_path="membrane_GT_inv",
           OriginalDataOnlyinTest=TRUE,
           FileName=paste0(DataFolder, "_5dTensor"))

filesstrings::file.move(files=paste0(DataFolder, "_5dTensor.Rds"),
                        destinations="./BioImageDbs_Output",
                        overwrite = TRUE)
Dat <- readRDS( paste0("./BioImageDbs_Output/", DataFolder, "_5dTensor.Rds") )
str(Dat); str(Dat$Train)
ImageView3D(Dat$Train, Interval=0.4, Name=paste0(DataFolder, "_5dTensor_train_dataset"))
filesstrings::file.move(files=paste0(DataFolder, "_5dTensor_train_dataset.gif"),
                        destinations="./BioImageDbs_Output",
                        overwrite = TRUE)

```

## EM_id0003_Drosophila_brain_region

```{r echo=TRUE, eval=FALSE}
#Set parameters
DataFolder <- "EM_id0003_J558L"
WIDTH00 <- 1024; HEIGHT00 <- 1024; CHANNELS00 <- 1

#Run the conversion
DataImport_2d_seg(WIDTH = WIDTH00, HEIGHT = HEIGHT00, CHANNELS = CHANNELS00,
                  data="./BioImageDbs_Data",
                  path01=DataFolder,
                  Original_path="OriginalData",
                  GroundTruth_path="GroundTruth_8b",
                  FileName=paste0(DataFolder, "_4dTensor"))

filesstrings::file.move(files=paste0(DataFolder, "_4dTensor.Rds"),
                        destinations="./BioImageDbs_Output",
                        overwrite = TRUE)
Dat <- readRDS( paste0("./BioImageDbs_Output/", DataFolder, "_4dTensor.Rds") )
#str(Dat); str(Dat$Train)
#table(Dat$Train$Train_GroundTruth)
Dat$Train$Train_GroundTruth[Dat$Train$Train_GroundTruth < 0.4] <- 0
ImageView2D(Dat$Train, Interval=0.8, Name=paste0(DataFolder, "_4dTensor_train_dataset"))
filesstrings::file.move(files=paste0(DataFolder, "_4dTensor_train_dataset.gif"),
                        destinations="./BioImageDbs_Output",
                        overwrite = TRUE)

```

## EM_id0004_PrHudata

```{r echo=TRUE, eval=FALSE}
#Set parameters
DataFolder <- "EM_id0004_PrHudata"
WIDTH00 <- 1024; HEIGHT00 <- 1024; CHANNELS00 <- 1
#Run the conversion
DataImport_2d_seg(WIDTH = WIDTH00, HEIGHT = HEIGHT00, CHANNELS = CHANNELS00,
                  data="./BioImageDbs_Data",
                  path01=DataFolder,
                  Original_path="OriginalData",
                  GroundTruth_path="GroundTruth_8b",
                  FileName=paste0(DataFolder, "_4dTensor"))

filesstrings::file.move(files=paste0(DataFolder, "_4dTensor.Rds"),
                        destinations="./BioImageDbs_Output",
                        overwrite = TRUE)
Dat <- readRDS( paste0("./BioImageDbs_Output/", DataFolder, "_4dTensor.Rds") )
#str(Dat); str(Dat$Train)
#table(Dat$Train$Train_GroundTruth)
Dat$Train$Train_GroundTruth[Dat$Train$Train_GroundTruth < 0.4] <- 0
ImageView2D(Dat$Train, Interval=0.8, Name=paste0(DataFolder, "_4dTensor_train_dataset"))
filesstrings::file.move(files=paste0(DataFolder, "_4dTensor_train_dataset.gif"),
                        destinations="./BioImageDbs_Output",
                        overwrite = TRUE)
```

## LM_id0001_DIC_C2DH_HeLa

```{r echo=TRUE, eval=FALSE}
#Set parameters
DataFolder <- "LM_id0001_DIC_C2DH_HeLa"
WIDTH00 <- 512; HEIGHT00 <- 512; CHANNELS00 <- 1
#Run the conversion
#Multi-label / 4d-tensor
DataImport_2d_seg(WIDTH = WIDTH00, HEIGHT = HEIGHT00, CHANNELS = CHANNELS00,
                  data="./BioImageDbs_Data",
                  path01=DataFolder,
                  Original_path="OriginalData",
                  GroundTruth_path="Cell_GroundTruth_8b",
                  FileName=paste0(DataFolder, "_4dTensor"))

filesstrings::file.move(files=paste0(DataFolder, "_4dTensor.Rds"),
                        destinations="./BioImageDbs_Output",
                        overwrite = TRUE)
Dat <- readRDS( paste0("./BioImageDbs_Output/", DataFolder, "_4dTensor.Rds") )
str(Dat); str(Dat$Train)
ImageView2D(Dat$Train, Interval=0.25, Name=paste0(DataFolder, "_4dTensor_train_dataset"))
filesstrings::file.move(files=paste0(DataFolder, "_4dTensor_train_dataset.gif"),
                        destinations="./BioImageDbs_Output",
                        overwrite = TRUE)
#ImageViewGif("LM_id0001_DIC_C2DH_HeLa.gif")

#Binary label / 4d-tensor
DataImport_2d_seg(WIDTH = WIDTH00, HEIGHT = HEIGHT00, CHANNELS = CHANNELS00,
                  data="./BioImageDbs_Data",
                  path01=DataFolder,
                  Original_path="OriginalData",
                  GroundTruth_path="Cell_GroundTruth_8b",
                  FileName=paste0(DataFolder, "_4dTensor"),
                  Binary=TRUE)
filesstrings::file.move(files=paste0(DataFolder, "_4dTensor_Binary.Rds"),
                        destinations="./BioImageDbs_Output",
                        overwrite = TRUE)
Dat <- readRDS( paste0("./BioImageDbs_Output/", DataFolder, "_4dTensor_Binary.Rds") )
str(Dat); str(Dat$Train)
ImageView2D(Dat$Train, Interval=0.25, Name=paste0(DataFolder, "_4dTensor_Binary_train_dataset"))
filesstrings::file.move(files=paste0(DataFolder, "_4dTensor_Binary_train_dataset.gif"),
                        destinations="./BioImageDbs_Output",
                        overwrite = TRUE)

#Multi-label / 5d-tensor
DataImport_3d_seg(WIDTH = WIDTH00, HEIGHT = HEIGHT00, Z=-1, CHANNELS = CHANNELS00,
           data="./BioImageDbs_Data",
           path01=DataFolder,
           Original_path="OriginalData_3D",
           GroundTruth_path="Cell_GroundTruth_8b_3D",
           OriginalDataOnlyinTest=FALSE,
           FileName=paste0(DataFolder, "_5dTensor"))

filesstrings::file.move(files=paste0(DataFolder, "_5dTensor.Rds"),
                        destinations="./BioImageDbs_Output",
                        overwrite = TRUE)
Dat <- readRDS( paste0("./BioImageDbs_Output/", DataFolder, "_5dTensor.Rds") )
str(Dat); str(Dat$Train)
ImageView3D(Dat$Train, Interval=0.25, Name=paste0(DataFolder, "_5dTensor_train_dataset"))
filesstrings::file.move(files=paste0(DataFolder, "_5dTensor_train_dataset.gif"),
                        destinations="./BioImageDbs_Output",
                        overwrite = TRUE)
```

## LM_id0002_PhC_C2DH_U373

```{r echo=TRUE, eval=FALSE}
#Set parameters
DataFolder <- "LM_id0002_PhC_C2DH_U373"
WIDTH00 <- 696; HEIGHT00 <- 520; CHANNELS00 <- 1
#Multi-label / 4d-tensor
DataImport_2d_seg(WIDTH = WIDTH00, HEIGHT = HEIGHT00, CHANNELS = CHANNELS00,
                  data="./BioImageDbs_Data",
                  path01=DataFolder,
                  Original_path="OriginalData",
                  GroundTruth_path="Cell_GroundTruth_8b",
                  FileName=paste0(DataFolder, "_4dTensor"))

filesstrings::file.move(files=paste0(DataFolder, "_4dTensor.Rds"),
                        destinations="./BioImageDbs_Output",
                        overwrite = TRUE)
Dat <- readRDS( paste0("./BioImageDbs_Output/", DataFolder, "_4dTensor.Rds") )
str(Dat); str(Dat$Train)
ImageView2D(Dat$Train, Interval=0.25, Name=paste0(DataFolder, "_4dTensor_train_dataset"))
filesstrings::file.move(files=paste0(DataFolder, "_4dTensor_train_dataset.gif"),
                        destinations="./BioImageDbs_Output",
                        overwrite = TRUE)
#ImageViewGif("LM_id0001_DIC_C2DH_HeLa.gif")

#Binary label / 4d-tensor
DataImport_2d_seg(WIDTH = WIDTH00, HEIGHT = HEIGHT00, CHANNELS = CHANNELS00,
                  data="./BioImageDbs_Data",
                  path01=DataFolder,
                  Original_path="OriginalData",
                  GroundTruth_path="Cell_GroundTruth_8b",
                  FileName=paste0(DataFolder, "_4dTensor"),
                  Binary=TRUE)
filesstrings::file.move(files=paste0(DataFolder, "_4dTensor_Binary.Rds"),
                        destinations="./BioImageDbs_Output",
                        overwrite = TRUE)
Dat <- readRDS( paste0("./BioImageDbs_Output/", DataFolder, "_4dTensor_Binary.Rds") )
str(Dat); str(Dat$Train)
ImageView2D(Dat$Train, Interval=0.25, Name=paste0(DataFolder, "_4dTensor_Binary_train_dataset"))
filesstrings::file.move(files=paste0(DataFolder, "_4dTensor_Binary_train_dataset.gif"),
                        destinations="./BioImageDbs_Output",
                        overwrite = TRUE)

#Multi-label / 5d-tensor
DataImport_3d_seg(WIDTH = WIDTH00, HEIGHT = HEIGHT00, Z=-1, CHANNELS = CHANNELS00,
           data="./BioImageDbs_Data",
           path01=DataFolder,
           Original_path="OriginalData_3D",
           GroundTruth_path="Cell_GroundTruth_8b_3D",
           OriginalDataOnlyinTest=FALSE,
           FileName=paste0(DataFolder, "_5dTensor"))

filesstrings::file.move(files=paste0(DataFolder, "_5dTensor.Rds"),
                        destinations="./BioImageDbs_Output",
                        overwrite = TRUE)
Dat <- readRDS( paste0("./BioImageDbs_Output/", DataFolder, "_5dTensor.Rds") )
str(Dat); str(Dat$Train)
#ImageView3D(Dat$Train, Interval=0.25, Name=paste0(DataFolder, "_5dTensor_train_dataset"))
#filesstrings::file.move(files=paste0(DataFolder, "_5dTensor_train_dataset.gif"),
#                        destinations="./BioImageDbs_Output",
#                        overwrite = TRUE)
```


## LM_id0003_Fluo_N2DH_GOWT1

```{r echo=TRUE, eval=FALSE}
#Set parameters
DataFolder <- "LM_id0003_Fluo_N2DH_GOWT1"
WIDTH00 <- 1024; HEIGHT00 <- 1024; CHANNELS00 <- 1
#Multi-label / 4d-tensor
DataImport_2d_seg(WIDTH = WIDTH00, HEIGHT = HEIGHT00, CHANNELS = CHANNELS00,
                  data="./BioImageDbs_Data",
                  path01=DataFolder,
                  Original_path="OriginalData",
                  GroundTruth_path="Cell_GroundTruth_8b",
                  FileName=paste0(DataFolder, "_4dTensor"))

filesstrings::file.move(files=paste0(DataFolder, "_4dTensor.Rds"),
                        destinations="./BioImageDbs_Output",
                        overwrite = TRUE)
Dat <- readRDS( paste0("./BioImageDbs_Output/", DataFolder, "_4dTensor.Rds") )
str(Dat); str(Dat$Train)
ImageView2D(Dat$Train, Interval=0.25, Name=paste0(DataFolder, "_4dTensor_train_dataset"))
filesstrings::file.move(files=paste0(DataFolder, "_4dTensor_train_dataset.gif"),
                        destinations="./BioImageDbs_Output",
                        overwrite = TRUE)

#Binary label / 4d-tensor
DataImport_2d_seg(WIDTH = WIDTH00, HEIGHT = HEIGHT00, CHANNELS = CHANNELS00,
                  data="./BioImageDbs_Data",
                  path01=DataFolder,
                  Original_path="OriginalData",
                  GroundTruth_path="Cell_GroundTruth_8b",
                  FileName=paste0(DataFolder, "_4dTensor"),
                  Binary=TRUE)
filesstrings::file.move(files=paste0(DataFolder, "_4dTensor_Binary.Rds"),
                        destinations="./BioImageDbs_Output",
                        overwrite = TRUE)
Dat <- readRDS( paste0("./BioImageDbs_Output/", DataFolder, "_4dTensor_Binary.Rds") )
str(Dat); str(Dat$Train)
ImageView2D(Dat$Train, Interval=0.25, Name=paste0(DataFolder, "_4dTensor_Binary_train_dataset"))
filesstrings::file.move(files=paste0(DataFolder, "_4dTensor_Binary_train_dataset.gif"),
                        destinations="./BioImageDbs_Output",
                        overwrite = TRUE)

#Multi-label / 5d-tensor
DataImport_3d_seg(WIDTH = WIDTH00, HEIGHT = HEIGHT00, Z=-1, CHANNELS = CHANNELS00,
           data="./BioImageDbs_Data",
           path01=DataFolder,
           Original_path="OriginalData_3D",
           GroundTruth_path="Cell_GroundTruth_8b_3D",
           OriginalDataOnlyinTest=FALSE,
           FileName=paste0(DataFolder, "_5dTensor"))

filesstrings::file.move(files=paste0(DataFolder, "_5dTensor.Rds"),
                        destinations="./BioImageDbs_Output",
                        overwrite = TRUE)
Dat <- readRDS( paste0("./BioImageDbs_Output/", DataFolder, "_5dTensor.Rds") )
str(Dat); str(Dat$Train)
#ImageView3D(Dat$Train, Interval=0.25, Name=paste0(DataFolder, "_5dTensor_train_dataset"))
#filesstrings::file.move(files=paste0(DataFolder, "_5dTensor_train_dataset.gif"),
#                        destinations="./BioImageDbs_Output",
#                        overwrite = TRUE)
```


## Display the GIF animations

```{r echo=TRUE, eval=FALSE}
#Set parameters
#DataFolder <- "EM_id0001_Brain_CA1_hippocampus_region"
#Display the GIF image
#id0001 <- Display.GIF(GifFileName=paste0("./BioImageDbs_Output/", DataFolder, "_5dTensor_train_dataset.gif"), View=TRUE)
#id0001
#str(id0001)
#class(id0001)

```

---
title: "The BioImageBbs Datasets"
author: 
- name: Satoshi Kume
  email: satoshi.kume.1984@gmail.com
date: "`r Sys.Date()`"
graphics: no
package: BioImageDbs, magick
output:
  BiocStyle::html_document:
      toc_float: true
vignette: >
  %\VignetteIndexEntry{The BioImageBbs Datasets}
  %\VignetteEncoding{UTF-8}
  %\VignetteDepends{ExperimentHub}
  %\VignetteEngine{knitr::rmarkdown}
editor_options: 
  chunk_output_type: console
---

```{r style, echo = FALSE, results = 'asis', message=FALSE}
BiocStyle::markdown()
```

**Last modified:** `r file.info("BioImageDbs_Datasets.Rmd")$mtime`<br/>
**Compiled**: `r Sys.time()`

# Fetch Bioimage Datasets from ExperimentHub

The `BioImageDbs` package provides the metadata for bioimage datasets,
which is preprocessed as array format and saved in 
`r Biocpkg("ExperimentHub")`.

# ExperimentHub package

First we load/update the `ExperimentHub` resource.

```{r load-lib, message = FALSE}
library(ExperimentHub)
eh <- ExperimentHub()
```

# Simaple query

We can retrieve only the BioImageDbs tibble files as follows.

```{r echo=TRUE, eval=TRUE}
qr <- query(eh, c("BioImageDbs"))
qr
```

We can use the `$` symbol to access metadata such as the id and title.

```{r echo=TRUE, eval=TRUE}
#Show metadata (e.g. ah_id and title)
qr$ah_id
qr$title
```

# About datasets

In this section, the query to retrieve each bioimage dataset will be introduced.

## EM_id0001: Mouse brain neurons (5D Array / Tensor)

```{r echo=TRUE, eval=TRUE}
qr <- query(eh, c("BioImageDbs", "EM_id0001"))

##Show metadata
qr

##Import data
#Img_Data <- qr[[1]]
gif_Data <- qr[[2]]

#Show animation
library(magick)
magick::image_read(gif_Data)
```

## EM_id0002: Drosophila brain neurons (5D Array / Tensor)

```{r echo=TRUE, eval=TRUE}
qr <- query(eh, c("BioImageDbs", "EM_id0002"))

##Show metadata
qr

##Import data
#Img_Data <- qr[[1]]
gif_Data <- qr[[2]]

#Show animation
magick::image_read(gif_Data)
```

## EM_id0003: J558L cells (4D Array / Tensor)

```{r echo=TRUE, eval=TRUE}
qr <- query(eh, c("BioImageDbs", "EM_id0003"))

##Show metadata
qr

##Import data
#Img_Data <- qr[[1]]

#Show animation
gif_Data <- qr[[2]]
magick::image_read(gif_Data)
```

## EM_id0004: primary human T cells (4D Array / Tensor)

```{r echo=TRUE, eval=TRUE}
qr <- query(eh, c("BioImageDbs", "EM_id0004"))

##Show metadata
qr

##Import data
#Img_Data <- qr[[1]]

#Show animation
gif_Data <- qr[[2]]
magick::image_read(gif_Data)
```

## EM_id0005: Mouse Kidney 2D imaging (4D Array / Tensor)

```{r echo=TRUE, eval=TRUE}
qr <- query(eh, c("BioImageDbs", "EM_id0005"))

##Show metadata
qr

##Import data
#Img_Data <- qr[[1]]

#Show animation
gif_Data <- qr[[2]]
magick::image_read(gif_Data)
```

## EM_id0006: Rat Liver 2D imaging (4D Array / Tensor)

```{r echo=TRUE, eval=TRUE}
qr <- query(eh, c("BioImageDbs", "EM_id0006"))

##Show metadata
qr

##Import data
#Img_Data <- qr[[1]]

#Show animation
gif_Data <- qr[[2]]
magick::image_read(gif_Data)
```

## EM_id0007: Mouse Kidney MultiScale images (4D Array / Tensor)

```{r echo=TRUE, eval=TRUE}
qr <- query(eh, c("BioImageDbs", "EM_id0007"))

##Show metadata
qr

##Import data
#Img_Data <- qr[[1]]

#Show animation
gif_Data <- qr[[2]]
magick::image_read(gif_Data)
```

## EM_id0008: Human NB4 cells (4D Array / Tensor)

```{r echo=TRUE, eval=TRUE}
qr <- query(eh, c("BioImageDbs", "EM_id0008"))

##Show metadata
qr

##Import data
#Img_Data <- qr[[1]]

#Show animation
gif_Data <- qr[[2]]
magick::image_read(gif_Data)
```

## EM_id0009: Murine BMMC cells (4D Array / Tensor)

```{r echo=TRUE, eval=TRUE}
qr <- query(eh, c("BioImageDbs", "EM_id0009"))

##Show metadata
qr

##Import data
#Img_Data <- qr[[1]]

#Show animation
gif_Data <- qr[[2]]
magick::image_read(gif_Data)
```

## EM_id0010: Human Blast cells (4D Array / Tensor)

```{r echo=TRUE, eval=TRUE}
qr <- query(eh, c("BioImageDbs", "EM_id0010"))

##Show metadata
qr

##Import data
#Img_Data <- qr[[1]]

#Show animation
gif_Data <- qr[[2]]
magick::image_read(gif_Data)
```

## EM_id0011: human T-cell line Jurkat cells (4D Array / Tensor)

```{r echo=TRUE, eval=TRUE}
qr <- query(eh, c("BioImageDbs", "EM_id0011"))

##Show metadata
qr

##Import data
#Img_Data <- qr[[1]]

#Show animation
gif_Data <- qr[[2]]
magick::image_read(gif_Data)
```

## LM_id0001: HeLa cells (4D Array / Tensor)

```{r echo=TRUE, eval=TRUE}
qr <- query(eh, c("BioImageDbs", "LM_id0001"))

##Show metadata
qr

##Import data
#Img_Data <- qr[[1]]

#Show animation
gif_Data <- qr[[2]]
magick::image_read(gif_Data)
```

## LM_id0002: Human glioblastoma-astrocytoma U373 cells (4D Array / Tensor)

```{r echo=TRUE, eval=TRUE}
qr <- query(eh, c("BioImageDbs", "LM_id0002"))

##Show metadata
qr

##Import data
#Img_Data <- qr[[1]]

#Show animation
gif_Data <- qr[[2]]
magick::image_read(gif_Data)
```

## LM_id0003: GFP-GOWT1 mouse stem cells (4D Array / Tensor)

```{r echo=TRUE, eval=TRUE}
qr <- query(eh, c("BioImageDbs", "LM_id0003"))

##Show metadata
qr

##Import data
#Img_Data <- qr[[1]]

#Show animation
gif_Data <- qr[[2]]
magick::image_read(gif_Data)
```


# Session information {.unnumbered}

```{r sessionInfo, echo=FALSE}
sessionInfo()
```

---
title: "make-data_for_v02"
author: 
- name: Satoshi Kume
  email: satoshi.kume.1984@gmail.com
date: "`r Sys.Date()`"
graphics: no
package: BioImageDbs
output:
  BiocStyle::html_document:
      toc_float: false
vignette: >
  %\VignetteIndexEntry{make-data_for_v02}
  %\VignetteEncoding{UTF-8}
  %\VignetteDepends{ExperimentHub}
  %\VignetteEngine{knitr::rmarkdown}
editor_options: 
  chunk_output_type: console
---


```{r style, echo = FALSE, results = 'asis', message=FALSE}
BiocStyle::markdown()
```

**Compiled**: `r date()`

**This script for the v02 dataset**

# Load the package

```{r echo=TRUE, eval=FALSE}
#Install
#rm(list=ls())
#devtools::install_github( "kumeS/BioImageDbs", force = TRUE )
library(BioImageDbs)

#Source
source(system.file("scripts", "./v02/ImgProc_for_v02.R", package="BioImageDbs"))
source(system.file("scripts", "./v02/ImageView_for_v02.R", package="BioImageDbs"))
```

# Convert the images to the array data in R

## SampleDataset_cats_segmentation

```{r echo=TRUE, eval=FALSE}
#Set parameters
DataFolder <- "SampleDataset_cats_segmentation"
DataPath <- "./BioImageDbs_02_Dataset_v02"
WIDTH00 <- 128; HEIGHT00 <- 128; CHANNELS01 <- 3; CHANNELS02 <- 1

#Run the conversion
DataImport_2d_seg(WIDTH = WIDTH00, HEIGHT = HEIGHT00,
                  CHANNELS01 = CHANNELS01, CHANNELS02 = CHANNELS02,
                  data=DataPath,
                  path01=DataFolder,
                  Original_path="OriginalData",
                  GroundTruth_path="GroundTruth_8b",
                  FileName=paste0(DataFolder, "_4dTensor"),
                  Binary=FALSE)

#Move data
filesstrings::file.move(files=paste0(DataFolder, "_4dTensor.Rds"),
                        destinations=DataPath, overwrite = TRUE)
#Read data
Dat <- readRDS( paste0(DataPath, "/", DataFolder, "_4dTensor.Rds") )
str(Dat)
table(Dat$Train$Train_GroundTruth)

ImageView2D(Dat$Train, Interval=0.8, Name=paste0(DataFolder, "_4dTensor_train_dataset"))
filesstrings::file.move(files=paste0(DataFolder, "_4dTensor_train_dataset.gif"),
                        destinations=DataPath, overwrite = TRUE)

#Metadata
Meta.Rds <- data.frame(
  Title="SampleDataset_cats_segmentation.rds",
  Description="4D arrays for cat-segmentation dataset provided by @taashi. Training dataset is 60 image pairs and test dataset is 20 image pairs. Image size is 128x128 px. Original images are RGB color.",	
  BiocVersion="3.13",
  Genome="NA",
  SourceType="PNG",
  SourceUrl="https://github.com/kumeS/BioImageDbs",
  SourceVersion="Apr 9 2018",
  Species="Felis catus",
  TaxonomyId="9685",
  Coordinate_1_based="NA",
  DataProvider="https://github.com/taashi-s/UNet_Keras",
  Maintainer="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  RDataClass="List",
  DispatchClass="Rds",
  RDataPath="BioImageDbs/v02/SampleDataset_cats_segmentation.rds",
  Tags="segmentation:2D images:SampleImage")
Meta.gif <- data.frame(
  Title="SampleDataset_cats_segmentation.gif",
  Description="A animation file (.gif) of the train dataset of SampleDataset_cats_segmentation.rds",	
  BiocVersion="3.13",
  Genome="NA",
  SourceType="PNG",
  SourceUrl="https://github.com/kumeS/BioImageDbs",
  SourceVersion="Apr 9 2018",
  Species="Felis catus",
  TaxonomyId="9685",
  Coordinate_1_based="NA",
  DataProvider="https://github.com/taashi-s/UNet_Keras",
  Maintainer="Satoshi Kume <satoshi.kume.1984@gmail.com>",
  RDataClass="magick-image",
  DispatchClass="FilePath",
  RDataPath="BioImageDbs/v02/SampleDataset_cats_segmentation.gif",
  Tags="segmentation:2D images:SampleImage")

readr::write_csv(Meta.Rds, file = "Metadata.csv", append = T, col_names = F)
readr::write_csv(Meta.gif, file = "Metadata.csv", append = T, col_names = F)


```

---
title: "Providing Bioimage Dataset for ExperimentHub"
author: 
- name: Satoshi Kume
  email: satoshi.kume.1984@gmail.com
date: "`r Sys.Date()`"
graphics: no
package: BioImageDbs
output:
  BiocStyle::html_document:
      toc_float: true
bibliography: BioImageDbs.bib
csl: bj.csl
vignette: >
  %\VignetteIndexEntry{Providing Bioimage Dataset for ExperimentHub}
  %\VignetteEncoding{UTF-8}
  %\VignetteDepends{ExperimentHub}
  %\VignetteEngine{knitr::rmarkdown}
editor_options: 
  chunk_output_type: console
---

```{r style, echo = FALSE, results = 'asis', message=FALSE}
BiocStyle::markdown()
```

**Last modified:** `r file.info("BioImageDbs.Rmd")$mtime`<br />
**Compiled**: `r Sys.time()`

# Utilisation and prospects of bioimage datasets

In recent years, there has been a growing need for data analysis using machine
learning in the field of bioimaging research. Machine learning is an inductive
approach using data, and the construction of models, such as image segmentation
and classification, involves the use of image data itself. Therefore, the
publication and sharing of bioimage datasets [@Williams2017] as well as knowledge creation
through providing metadata to bioimages [@Kobayashi2018;@Kume2017] are important issues to be 
discussed. At present, there is no commonly used format for sharing bioimage
datasets. Also, the data is scattered among various repositories. Therefore,
different image repositories manage the data in different formats (image data 
itself and metadata, including image format, instruments/microscopes and
biosamples).

In the data analysis and quantification using those images, it is assumed that
several steps of image pre-processing are performed depending on the analysis
environment used. However, the implementation of supervised learning starts with
finding a repository of the bioimage dataset that contains original images and 
their corresponding supervised labels. Once the repository is found, the image 
data is downloaded from the repository, the data is loaded into each 
environment and it is prepared in a format suitable for analytical package. 
These processes are time consuming before the main analysis. Also, in most of 
the image repositories, the data are not published in a format suitable for 
reading and processing in R (.Rdata, etc.), and the data are not easy to use 
for R users. 

For performing supervised learning of bioimage data, BioImageDbs provides R 
list objects of the original images and their corresponding supervised labels
converted into a 4D or 5D array. After retrieving the data from ExperimentHub, 
it can be utilised for deep learning using Keras/Tensorflow [@Chollet2017kerasR] 
and other machine learning methods, without the need for pre-processing.

On the other hand, many image analysis packages are also available on R; 
however, there is a lack of standardisation in image analysis. The use of 
common, open datasets is one of the essential steps in standardising and 
comparing the analytical methods. The provision of the array data of images 
through ExperimentHub is also intended for applications such as (1) comparing 
models using common-sharing data among R users and (2) applying predictions 
to new datasets through transfer learning and fine-tuning based on these arrays.

# Fetch Bioimage Datasets from ExperimentHub

The `BioImageDbs` package provides the metadata for all BioImage 
databases in `r Biocpkg("ExperimentHub")`. 

The `BioImageDbs` package provides the metadata for bioimage datasets,
which is preprocessed as array format and saved in
`r Biocpkg("ExperimentHub")`.

First we load/update the `ExperimentHub` resource.

```{r load-lib, message = FALSE}
library(ExperimentHub)
eh <- ExperimentHub()
```

Next we list all BioImageDbs entries from `ExperimentHub`.

```{r list-BioImageDbs}
query(eh, "BioImage")
```

We can confirm the metadata in ExperimentHub in Bioconductor S3 bucket
with `mcols()`.

```{r confirm-metadata}
mcols(query(eh, "BioImage"))
```

We can retrieve only the BioImageDbs tibble files as follows.

```{r query-mouse}
qr <- query(eh, c("BioImageDbs", "LM_id0001"))
qr

#Import data
#BioImageDbs_image_Dat <- qr[[1]]
```

# 5D Arrays from the ExperimentHub

The ordering of the array dimensions corresponds to the channels_last format
(default) in R/Keras. The input shape of 5D array is to be batch, spatial_dim1,
spatial_dim2, spatial_dim3 and channels. The number of this batch is the same 
as the number of the 3D image sets. The number of channels is 1 for grey 
images and 3 for RGB images.

# 4D Arrays from the ExperimentHub

The ordering of the array dimensions corresponds to the channels_last format
(default) in R/Keras. The input shape of 4D array is to be batch, height, 
width and channels. The number of this batch is the same as the number of 
the 2D images.

# Visualization of gif images from the ExperimentHub

As a test, we also provided gif files of some arrays for visualizations.
We visualize the files using `magick::image_read` function.

```{r}
qr <- query(eh, c("BioImageDbs", ".gif"))
qr

#EM_id0001_Brain_CA1_hippocampus_region_5dTensor_train_data
qr[1]

##Display the gif image
#magick::image_read(qr[[1]])
```

```{r Fig001, fig.cap = "EM_id0001_Brain_CA1_hippocampus_region_5dTensor_train_dataset.gif", echo = FALSE}
#magick::image_read(qr[[1]])
options(EBImage.display = "raster")
img <- system.file("images", "EM_id0001.png", package="BioImageDbs")
EBImage::display(EBImage::readImage(files = img))
```

```{r Fig002, fig.cap = "EM_id0002_Drosophila_brain_region_5dTensor_train_dataset.gif", echo = FALSE}
#magick::image_read(qr[[2]])
options(EBImage.display = "raster")
img <- system.file("images", "EM_id0002.png", package="BioImageDbs")
EBImage::display(EBImage::readImage(files = img))
```

```{r Fig003, fig.cap = "EM_id0003_J558L_4dTensor_train_dataset.gif", echo = FALSE}
#magick::image_read(qr[[9]])
options(EBImage.display = "raster")
img <- system.file("images", "EM_id0003.png", package="BioImageDbs")
EBImage::display(EBImage::readImage(files = img))
```

```{r Fig004, fig.cap = "EM_id0004_PrHudata_4dTensor_train_dataset.gif", echo = FALSE}
#magick::image_read(qr[[10]])
options(EBImage.display = "raster")
img <- system.file("images", "EM_id0004.png", package="BioImageDbs")
EBImage::display(EBImage::readImage(files = img))
```

```{r Fig008, fig.cap = "EM_id0005_Mouse_Kidney_2D_All_Mito_1024_4dTensor_dataset.gif", echo = FALSE}
options(EBImage.display = "raster")
img <- system.file("images", "EM_id0005_Mouse_Kidney_2D_Mito.png", package="BioImageDbs")
EBImage::display(EBImage::readImage(files = img))
```

```{r Fig009, fig.cap = "EM_id0005_Mouse_Kidney_2D_All_Nuc_1024_4dtensor.Rds", echo = FALSE}
options(EBImage.display = "raster")
img <- system.file("images", "EM_id0005_Mouse_Kidney_2D_Nuc.png", package="BioImageDbs")
EBImage::display(EBImage::readImage(files = img))
```

```{r Fig010, fig.cap = "EM_id0006_Rat_Liver_2D_All_Mito_1024_4dTensor_dataset.gif", echo = FALSE}
options(EBImage.display = "raster")
img <- system.file("images", "EM_id0006_Rat_Liver_Mito.png", package="BioImageDbs")
EBImage::display(EBImage::readImage(files = img))
```


```{r Fig011, fig.cap = "EM_id0006_Rat_Liver_2D_All_Nuc_1024_4dTensor_dataset.gif", echo = FALSE}
options(EBImage.display = "raster")
img <- system.file("images", "EM_id0006_Rat_Liver_Nuc.png", package="BioImageDbs")
EBImage::display(EBImage::readImage(files = img))
```

```{r Fig012, fig.cap = "EM_id0007_Mouse_Kidney_MultiScale_All_Low_Glomerulus_1024_4dTensor_dataset.gif", echo = FALSE}
options(EBImage.display = "raster")
img <- system.file("images", "EM_id0007_Mouse_Kidney_MultiScale_Glomerulus.png", package="BioImageDbs")
EBImage::display(EBImage::readImage(files = img))
```

```{r Fig013, fig.cap = "EM_id0007_Mouse_Kidney_MultiScale_All_Middle_Podocyte_1024_4dTensor_dataset.gif", echo = FALSE}
options(EBImage.display = "raster")
img <- system.file("images", "EM_id0007_Mouse_Kidney_MultiScale_Podocyte.png", package="BioImageDbs")
EBImage::display(EBImage::readImage(files = img))
```

```{r Fig014, fig.cap = "EM_id0008_Human_NB4_2D_All_Cel_512_4dTensor_dataset.gif", echo = FALSE}
options(EBImage.display = "raster")
img <- system.file("images", "EM_id0008_Human_NB4_Nuc.png", package="BioImageDbs")
EBImage::display(EBImage::readImage(files = img))
```

```{r Fig015, fig.cap = "EM_id0008_Human_NB4_2D_All_Nuc_1024_4dTensor_dataset.gif", echo = FALSE}
options(EBImage.display = "raster")
img <- system.file("images", "EM_id0008_Human_NB4_Cell.png", package="BioImageDbs")
EBImage::display(EBImage::readImage(files = img))
```

```{r Fig016, fig.cap = "EM_id0009_MurineBMMC_All_512_4dTensor_dataset.gif", echo = FALSE}
options(EBImage.display = "raster")
img <- system.file("images", "EM_id0009.png", package="BioImageDbs")
EBImage::display(EBImage::readImage(files = img))
```

```{r Fig017, fig.cap = "EM_id0010_HumanBlast_All_512_4dTensor_dataset.gif", echo = FALSE}
options(EBImage.display = "raster")
img <- system.file("images", "EM_id0010.png", package="BioImageDbs")
EBImage::display(EBImage::readImage(files = img))
```

```{r Fig018, fig.cap = "EM_id0011_HumanJurkat_All_512_4dTensor_dataset.gif", echo = FALSE}
options(EBImage.display = "raster")
img <- system.file("images", "EM_id0011.png", package="BioImageDbs")
EBImage::display(EBImage::readImage(files = img))
```

```{r Fig005, fig.cap = "LM_id0001_DIC_C2DH_HeLa_4dTensor_train_dataset.gif", echo = FALSE}
#magick::image_read(qr[[3]])
options(EBImage.display = "raster")
img <- system.file("images", "LM_id0001.png", package="BioImageDbs")
EBImage::display(EBImage::readImage(files = img))
```

```{r Fig006, fig.cap = "LM_id0002_PhC_C2DH_U373_4dTensor_train_dataset.gif", echo = FALSE}
#magick::image_read(qr[[5]])
options(EBImage.display = "raster")
img <- system.file("images", "LM_id0002.png", package="BioImageDbs")
EBImage::display(EBImage::readImage(files = img))
```

```{r Fig007, fig.cap = "LM_id0003_Fluo_N2DH_GOWT1_4dTensor_train_dataset.gif", echo = FALSE}
#magick::image_read(qr[[7]])
options(EBImage.display = "raster")
img <- system.file("images", "LM_id0003.png", package="BioImageDbs")
EBImage::display(EBImage::readImage(files = img))
```

# A simple execution command using Keras/Tensorflow

We select a data array and a label array from the data list and assign 
them to variables. These variables are then used as the x and y arguments 
of the fit (<keras.engine.training.Model>) function of Keras as an example. 
The model in Keras should be prepared before the execution.

```{r}
## Not Run ##
# qr <- query(eh, c("BioImageDbs"))
# BioImageData <- qr[[1]]
# data <- BioImageData$Train$Train_Original
# labels <- BioImageData$Train$Train_GroundTruth
# dim(data); dim(labels)
# model %>% fit( x = data, y = labels )
```

# About the imaging dataset and its metadata in BioImageDbs

For this dataset in BioImageDbs, the published open data was used as follows:

1.	For cellular ultra-microstructures, electron microscopy-based imaging data of 
mouse B myeloma cell line J558L (ex. EM_id0003_J558L_4dTensor.Rda) [@Morath2013] 
and primary human T cell isolated from peripheral blood mononuclear cells 
(ex. EM_id0004_PrHudata_4dTensor.Rda) [@Morath2013], Human NB-4 cell
(ex. EM_id0008_Human_NB4_2D_All_Cel_512_4dTensor.Rds) [@Kume2017], 
murine bone marrow derived-mast cells (ex. EM_id0009_MurineBMMC_All_512_4dTensor.Rds) [@Morath2013], 
human blasts (ex. EM_id0010_HumanBlast_All_512_4dTensor.Rds) [@Morath2013], and
human T-cell line Jurkat (ex. EM_id0011_HumanJurkat_All_512_4dTensor.Rds) [@Morath2013]
were used.

2. For bio-tissue ultra-microstructures, electron microscopy-based imaging data 
of the mouse brain (ex. EM_id0001_Brain_CA1_hippocampus_region_5dTensor.Rda) 
[@Lucchi2012;@Lucchi2013bib], Drosophila brain (ex. EM_id0002_Drosophila_brain_region_5dTensor.Rda) 
[@Cardona2010;@ArgandaCarreras2015], mouse kidney (ex. EM_id0005_Mouse_Kidney_2D_All_Nuc_1024_4dtensor.Rds) [@Kume2016]
and rat liver (ex. EM_id0006_Rat_Liver_2D_All_Mito_1024_4dtensor.Rds) [@Kume2016] were used.

3.	For cell tracking, light microscopy-based imaging data of the human HeLa 
cells on a flat glass (ex. LM_id0001_DIC_C2DH_HeLa_4dTensor.Rda) [@Maska2014;@Ulman2017], 
human glioblastoma-astrocytoma U373 cells on a polyacrylamide substrate 
(ex. LM_id0002_PhC_C2DH_U373_4dTensor.Rda) [@Maska2014;@Ulman2017] and GFP-GOWT1 mouse stem 
cells (ex. LM_id0003_Fluo_N2DH_GOWT1_4dTensor.Rda) [@Bartova2011] were used.

The values of the supervised labels were provided as array data with binary 
or multiple values. The detailed information was described in the metadata 
file of BioImageDbs. 
Some of cell tracking data were obtained from the [cell tracking challenge](http://celltrackingchallenge.net/2d-datasets/).

# Session information {.unnumbered}

```{r sessionInfo, echo=FALSE}
sessionInfo()
```

# References

\name{BioImageDbs-package}
\alias{BioImageDbs-package}
\alias{BioImageDbs}
\docType{package}
\title{
\packageTitle{BioImageDbs}
}
\description{
\packageDescription{BioImageDbs}
}
\details{
The DESCRIPTION file:
\packageDESCRIPTION{BioImageDbs}
\packageIndices{BioImageDbs}
}
\author{

\packageAuthor{BioImageDbs}

Maintainer: \packageMaintainer{BioImageDbs}
}

\keyword{ package }
\examples{
ls("package:BioImageDbs") # This is empty package
}
